package com.parking.HAPEstimation;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

/**
 * @author leon stenneth, lstennethATgmail.com
 *
 */

//POJO 'like' object
public final class HistoricalModel {
	private static int N;// number of parking slots on street
	private double fp;// false positive
	private double fn; //false negative
	private double b;// penetration ratio
	private double ai; // computed parking availability
	private double xi;// true parking availability
	private int street_block_id;
	private String startTimeFrameForValidation;  //start time stamp for history mean computation e.g. 2012-04-06 15:44:17.298
	private String endTimeFrameForValidation;
	private String startTimeFrameForHistory;  //start time stamp for history mean computation e.g. 2012-04-06 15:44:17.298
	private String endTimeFrameForHistory;
	
	private int history_start_hour;
	private int history_start_minute;
	private int history_start_second;
	private int history_end_hour;
	private int history_end_minute;
	private int history_end_second;
	private double psd_accuracy;
	
	public static int getN() {
		return N;
	}
	public void setN(int n) {
		N = n;
	}
	public double getFp() {
		return fp;
	}
	public void setFp(double fp) {
		this.fp = fp;
	}
	public double getFn() {
		return fn;
	}
	public void setFn(double fn) {
		this.fn = fn;
	}
	public double getB() {
		return b;
	}
	public void setB(double b) {
		this.b = b;
	}

	public double getAi() {
		return ai;
	}
	public void setAi(double ai) {
		this.ai = ai;
	}

	public double getXi() {
		return xi;
	}
	public void setXi(double xi) {
		this.xi = xi;
	}
	public int getStreet_block_id() {
		return street_block_id;
	}
	public void setStreet_block_id(int street_block_id) {
		this.street_block_id = street_block_id;
	}
	public String getStartTimeFrameForValidation() {
		return startTimeFrameForValidation;
	}
	public void setStartTimeFrameForValidation(String startTimeFrameForValidation) {
		this.startTimeFrameForValidation = startTimeFrameForValidation;
	}
	public String getEndTimeFrameForValidation() {
		return endTimeFrameForValidation;
	}
	public void setEndTimeFrameForValidation(String endTimeFrameForValidation) {
		this.endTimeFrameForValidation = endTimeFrameForValidation;
	}
	
	public int getHistory_start_hour() {
		return history_start_hour;
	}
	public void setHistory_start_hour(int history_start_hour) {
		this.history_start_hour = history_start_hour;
	}
	public int getHistory_start_minute() {
		return history_start_minute;
	}
	public void setHistory_start_minute(int history_start_minute) {
		this.history_start_minute = history_start_minute;
	}
	public int getHistory_start_second() {
		return history_start_second;
	}
	public void setHistory_start_second(int history_start_second) {
		this.history_start_second = history_start_second;
	}
	public int getHistory_end_hour() {
		return history_end_hour;
	}
	public void setHistory_end_hour(int history_end_hour) {
		this.history_end_hour = history_end_hour;
	}
	public int getHistory_end_minute() {
		return history_end_minute;
	}
	public void setHistory_end_minute(int history_end_minute) {
		this.history_end_minute = history_end_minute;
	}
	public int getHistory_end_second() {
		return history_end_second;
	}
	public void setHistory_end_second(int history_end_second) {
		this.history_end_second = history_end_second;
	}
	public double getPsd_accuracy() {
		return psd_accuracy;
	}
	public void setPsd_accuracy(double psd_accuracy) {
		this.psd_accuracy = psd_accuracy;
	}
	@Override
	public String toString() {
		return "HistoricalModel [N=" + N + ", fp=" + fp + ", fn=" + fn + ", b="
				+ b + ", ai=" + ai + ", xi=" + xi + "]";
	}

	/*public int resetNFromDataBase(int block){
		int numOfOperational = 0;
		try {
			Class.forName("org.postgresql.Driver").newInstance();
			Connection db=DriverManager.getConnection("jdbc:postgresql://localhost:5432/postgis","postgres","Yhcaapa3");	
			Statement stmt=db.createStatement();
			String historyQuery = "select operational from sfpark  where bfid = '"+block+"' group by operational";// and timestamp < '"+this.getEndTimeFrameForCrossValidation()+"' AND timestamp >= '"+this.getStartTimeFrameForCrossValidation()+"' AND extract(hour from timestamp) >= "+this.getCrossValidationStartHour()+" AND extract(hour from timestamp) <="+this.getCrossValidationEndHour()+" group by extract (day from timestamp)";
			ResultSet rs = stmt.executeQuery(historyQuery);
			while(rs.next()){
				numOfOperational = rs.getInt(1);
			}
			rs.close();
			stmt.close();
			db.close();
		}
		catch (Exception e){
			e.printStackTrace();
		}

		setN(numOfOperational);
		return numOfOperational;

	}
*/
	public ResultSet getValidationPieceOfDataFromDB(){
		ResultSet rs = null;
		try {
			Class.forName("org.postgresql.Driver").newInstance();
			Connection db=DriverManager.getConnection("jdbc:postgresql://localhost:5432/postgis","postgres","Yhcaapa3");	
			Statement stmt=db.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
			String historyQuery = "select extract (day from timestamp) as day, available, extract (hour from timestamp) as hour, timestamp, extract (minute from timestamp), extract (second from timestamp)  from block"+this.getStreet_block_id()+" where bfid = '"+this.getStreet_block_id()+"' and timestamp < '"+this.getEndTimeFrameForValidation()+"' AND timestamp >= '"+this.getStartTimeFrameForValidation()+"' order by timestamp asc";
			rs = stmt.executeQuery(historyQuery);
			//stmt.close();
			db.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		return rs;
	}
	public String getStartTimeFrameForHistory() {
		return startTimeFrameForHistory;
	}
	public void setStartTimeFrameForHistory(String startTimeFrameForHistory) {
		this.startTimeFrameForHistory = startTimeFrameForHistory;
	}
	public String getEndTimeFrameForHistory() {
		return endTimeFrameForHistory;
	}
	public void setEndTimeFrameForHistory(String endTimeFrameForHistory) {
		this.endTimeFrameForHistory = endTimeFrameForHistory;
	}

	
}
