package com.parking.HAPEstimation;

import java.util.ArrayList;
import java.util.Random;

/**
 * @author leon stenneth, lstennethATgmail.com
 *
 */
//POJO utility
public final class Utilities {
	private ArrayList<String> time_map;
	private ArrayList<Double> time_map_as_doubles;
	private ArrayList<Double> true_avl_list;
	private ArrayList<Double> historical_mean_list;
	private ArrayList<Double> historical_variance_list;
	private ArrayList<Double> HAP_list;
	
	private ArrayList<Double> spp_list;
	
	private ArrayList<Double> wa0_list;
	private ArrayList<Double> wa1_list;
	private ArrayList<Double> wa2_list;
	private ArrayList<Double> wa3_list;
	private ArrayList<Double> wa4_list;
	private ArrayList<Double> wa5_list;
	private ArrayList<Double> wa6_list;
	private ArrayList<Double> wa7_list;
	private ArrayList<Double> wa8_list;
	private ArrayList<Double> wa9_list;
	private ArrayList<Double> wa10_list;
	
	private ArrayList<Double> kmf_list;
	
	public Utilities() {
		super();
		this.time_map = new ArrayList<String>();
		this.true_avl_list = new ArrayList<Double>();
		this.time_map_as_doubles = new ArrayList<Double>();
		this.historical_mean_list = new ArrayList<Double>();
		this.historical_variance_list = new ArrayList<Double>();
		
		this.spp_list= new ArrayList<Double>();
		
		this.wa0_list = new ArrayList<Double>();
		this.wa1_list = new ArrayList<Double>();
		this.wa2_list = new ArrayList<Double>();
		this.wa3_list = new ArrayList<Double>();
		this.wa4_list = new ArrayList<Double>();
		this.wa5_list = new ArrayList<Double>();
		this.wa6_list = new ArrayList<Double>();
		this.wa7_list = new ArrayList<Double>();
		this.wa8_list = new ArrayList<Double>();
		this.wa9_list = new ArrayList<Double>();
		this.wa10_list = new ArrayList<Double>();
		
		this.kmf_list = new ArrayList<Double>();
		
		
		
		HAP_list = new ArrayList<Double>();
		// TODO Auto-generated constructor stub
	}

	public double getMean(ArrayList <Double> data)
    {
        double sum = 0.0;
        for(double a : data)
            sum += a;
         
        
        return sum/data.size();
    }

    public double getVariance(ArrayList <Double> data)
    {
            double mean = getMean(data);
            double temp = 0;
            for(double a :data)
                temp += (mean-a)*(mean-a);
                
           
            return temp/data.size();
    }
	
	public Utilities(ArrayList<String> time_map,
			ArrayList<Double> true_avl_list,
			ArrayList<Double> historical_mean_list,
			ArrayList<Double> historical_variance_list,
			ArrayList<Double> hAP_list) {
		super();
		this.time_map = time_map;
		this.true_avl_list = true_avl_list;
		this.historical_mean_list = historical_mean_list;
		this.historical_variance_list = historical_variance_list;
		HAP_list = hAP_list;
	}


	/**
	 * @return the time_map
	 */
	public ArrayList<String> getTime_map() {
		return time_map;
	}


	/**
	 * @param time_map the time_map to set
	 */
	public void setTime_map(ArrayList<String> time_map) {
		this.time_map = time_map;
	}

	
	/*public static int NBRandom(int r, double p, Random rg) {
        int a = 0;
        for (int i = 0; i < r; i++) {
            double Ui = rg.nextDouble();
            a += (int)(Math.log(Ui) / Math.log(1 - p));
        }
        return a;
    }*/
	
	public static int NBRandom(int r, double p, Random rg) {
        
        int a = 0;
        for (int i = 0; i < r; i++) {
            double Ui = rg.nextDouble();
            a += (int)(Math.log(Ui) / Math.log(p));
        }
        return a;
    }


	/**
	 * @return the true_avl_list
	 */
	public ArrayList<Double> getTrue_avl_list() {
		return true_avl_list;
	}


	/**
	 * @param true_avl_list the true_avl_list to set
	 */
	public void setTrue_avl_list(ArrayList<Double> true_avl_list) {
		this.true_avl_list = true_avl_list;
	}


	/**
	 * @return the historical_mean_list
	 */
	public ArrayList<Double> getHistorical_mean_list() {
		return historical_mean_list;
	}


	/**
	 * @param historical_mean_list the historical_mean_list to set
	 */
	public void setHistorical_mean_list(ArrayList<Double> historical_mean_list) {
		this.historical_mean_list = historical_mean_list;
	}


	/**
	 * @return the historical_variance_list
	 */
	public ArrayList<Double> getHistorical_variance_list() {
		return historical_variance_list;
	}


	/**
	 * @param historical_variance_list the historical_variance_list to set
	 */
	public void setHistorical_variance_list(
			ArrayList<Double> historical_variance_list) {
		this.historical_variance_list = historical_variance_list;
	}


	/**
	 * @return the hAP_list
	 */
	public ArrayList<Double> getHAP_list() {
		return HAP_list;
	}


	/**
	 * @param hAP_list the hAP_list to set
	 */
	public void setHAP_list(ArrayList<Double> hAP_list) {
		HAP_list = hAP_list;
	}


	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return String
				.format("Utilities [time_map=%s, true_avl_list=%s, historical_mean_list=%s, historical_variance_list=%s, HAP_list=%s]",
						time_map, true_avl_list, historical_mean_list,
						historical_variance_list, HAP_list);
	}
	
	public void convertTimeMapofStringToDoubles(){
		String string="";
		
		for(int index=0;index<this.getTime_map().size();index++){
			string=this.getTime_map().get(index);
			this.getTime_map_as_doubles().add(Double.parseDouble(string.split(":")[0])+(Double.parseDouble(string.split(":")[1])/60)) ;//status return Double.parseDouble(s.split(":")[0])+(Double.parseDouble(s.split(":")[1])/60);
		}
	}
	
	public void convertTimeMapofStringToDoublesPerSecond(){
		String string="";
		
		for(int index=0;index<this.getTime_map().size();index++){
			string=this.getTime_map().get(index);
			this.getTime_map_as_doubles().add(Double.parseDouble(string.split(":")[0])+(Double.parseDouble(string.split(":")[1])/60)+(Double.parseDouble(string.split(":")[2])/60)) ;//status return Double.parseDouble(s.split(":")[0])+(Double.parseDouble(s.split(":")[1])/60);
		}
	}
	
	public double convertTimeStringToDouble(String s){
		 return Double.parseDouble(s.split(":")[0])+(Double.parseDouble(s.split(":")[1])/60);
	}
	
	public double convertTimeStringToDoublePerSecond(String s){
		 return Double.parseDouble(s.split(":")[0])+(Double.parseDouble(s.split(":")[1])/60);
	}
	
	/**
	 * @return the time_map_as_doubles
	 */
	public ArrayList<Double> getTime_map_as_doubles() {
		return time_map_as_doubles;
	}


	/**
	 * @param time_map_as_doubles the time_map_as_doubles to set
	 */
	public void setTime_map_as_doubles(ArrayList<Double> time_map_as_doubles) {
		this.time_map_as_doubles = time_map_as_doubles;
	}


	public ArrayList<Double> getSpp_list() {
		return spp_list;
	}


	public void setSpp_list(ArrayList<Double> spp_list) {
		this.spp_list = spp_list;
	}


	public ArrayList<Double> getWa0_list() {
		return wa0_list;
	}


	public ArrayList<Double> getWa1_list() {
		return wa1_list;
	}


	public void setWa1_list(ArrayList<Double> wa1_list) {
		this.wa1_list = wa1_list;
	}


	public ArrayList<Double> getWa2_list() {
		return wa2_list;
	}


	public void setWa2_list(ArrayList<Double> wa2_list) {
		this.wa2_list = wa2_list;
	}


	public ArrayList<Double> getWa3_list() {
		return wa3_list;
	}


	public void setWa3_list(ArrayList<Double> wa3_list) {
		this.wa3_list = wa3_list;
	}


	public ArrayList<Double> getWa4_list() {
		return wa4_list;
	}


	public void setWa4_list(ArrayList<Double> wa4_list) {
		this.wa4_list = wa4_list;
	}


	public ArrayList<Double> getWa5_list() {
		return wa5_list;
	}


	public void setWa5_list(ArrayList<Double> wa5_list) {
		this.wa5_list = wa5_list;
	}


	public ArrayList<Double> getWa6_list() {
		return wa6_list;
	}


	public void setWa6_list(ArrayList<Double> wa6_list) {
		this.wa6_list = wa6_list;
	}


	public ArrayList<Double> getWa7_list() {
		return wa7_list;
	}


	public void setWa7_list(ArrayList<Double> wa7_list) {
		this.wa7_list = wa7_list;
	}


	public ArrayList<Double> getWa8_list() {
		return wa8_list;
	}


	public void setWa8_list(ArrayList<Double> wa8_list) {
		this.wa8_list = wa8_list;
	}


	public ArrayList<Double> getWa9_list() {
		return wa9_list;
	}


	public void setWa9_list(ArrayList<Double> wa9_list) {
		this.wa9_list = wa9_list;
	}


	public ArrayList<Double> getWa10_list() {
		return wa10_list;
	}


	public void setWa10_list(ArrayList<Double> wa10_list) {
		this.wa10_list = wa10_list;
	}


	public void setWa0_list(ArrayList<Double> wa_list) {
		this.wa0_list = wa_list;
	}


	public ArrayList<Double> getKmf_list() {
		return kmf_list;
	}


	public void setKmf_list(ArrayList<Double> kmf_list) {
		this.kmf_list = kmf_list;
	}


	
	
}
