package com.parking.PAEAlgorithms;

import java.util.ArrayList;

import com.parking.HAPEstimation.HAPConstruction;
import com.parking.HAPEstimation.HistoricalModel;
/**
 * @author leon stenneth, lstennethATgmail.com
 *
 */
public class KalmanFilter {

	private int x_hat; //state estimation

	public static ArrayList <Double>r_i_hat_list = new ArrayList <Double>(); 
	public static ArrayList <Double> Q_i_hat_list = new ArrayList<Double>(); 
	//public static ArrayList p_i_list = new ArrayList(); 
	
	private double kalman_estimation_or_kalman_xi=0.0;
	private double observation_residual=0.0;
	private static double rt=0;
	private static double Rt=0;
	private static int h=15; // for ALMF sliding window
	private  double r_i_hat; 
	private double kalman_gain;
	private static com.parking.PAEAlgorithms.ScaledPhonePark SPP;
	private static com.parking.HAPEstimation.HAPConstruction hm;
	private static com.parking.HAPEstimation.HistoricalModel m;
	


	public double computeKalmanStateEstimation (){
		this.updateTheErrorsUsingALMF();
		
		double yt = ScaledPhonePark.getSpp_xi()-HAPConstruction.getqt()-rt; //equation 4
		this.setObservation_residual(yt);

		double kt = HAPConstruction.getQt()/(HAPConstruction.getQt()+Rt); //equation 5
		this.setKalman_gain(kt);

		System.out.println("from kalman filter: SPP "+ScaledPhonePark.getSpp_xi());
		System.out.println("from kalman filter: qt "+HAPConstruction.getqt());
		
		System.out.println("from kalman filter: Qt "+HAPConstruction.getQt());
		System.out.println("from kalman filter: Rt "+Rt);
		
		System.out.println("from kalman filter: rt "+rt);
				
		//double xt = hm.getqt()+(kt*yt); //equation 6
		double xt = (Rt/(HAPConstruction.getQt()+Rt))*(hm.getqt())+(HAPConstruction.getQt()/(HAPConstruction.getQt()+Rt))*(ScaledPhonePark.getSpp_xi()-rt);

		//System.out.println("KM "+ xt1);
		this.setKalman_estimation_or_kalman_xi(xt);

		
		if(xt>HistoricalModel.getN()){//capping
			xt=HistoricalModel.getN();
		}
		else if (xt<0){//capping
			xt=0;
		}
		return xt;
	}

	public double BoVersionOfKalmanFilter2YangComment(){
		if (KalmanFilter.r_i_hat_list.size()>=h){
			KalmanFilter.r_i_hat_list.remove(0);
			KalmanFilter.Q_i_hat_list.remove(0);
		}
		this.setR_i_hat(ScaledPhonePark.getSpp_xi()-(hm.getqt()));
		KalmanFilter.r_i_hat_list.add(this.getR_i_hat());//save in r i hat list
		KalmanFilter.Q_i_hat_list.add(HAPConstruction.getQt());
		/*System.out.println("r_i_hat_list size : "+r_i_hat_list.size());
		System.out.println("r_i_hat_list : "+r_i_hat_list.toString());
		*/
		//compute rhat
		double total_r_i = 0;
		for (int index=0;index<KalmanFilter.r_i_hat_list.size();index++){
			total_r_i = total_r_i +KalmanFilter.r_i_hat_list.get(index);
		}
		
		double rHat = total_r_i/r_i_hat_list.size();
		
		
		//compute RHat
		double Cr;
		if(r_i_hat_list.size()==1){
			Cr = (this.getR_i_hat()-rHat)*(this.getR_i_hat()-rHat);
		}
		else {
			double total_Cr = 0;
			for(int index=0;index<KalmanFilter.r_i_hat_list.size();index++){
				total_Cr = total_Cr + (this.getR_i_hat()-rHat)*(this.getR_i_hat()-rHat);
			}
			Cr = total_Cr/(KalmanFilter.r_i_hat_list.size()-1);
		}
		
		//then compute sigma(PH^2)/N
		
		double total_PH = 0;
		for(int index=0;index<KalmanFilter.r_i_hat_list.size();index++){
			total_PH = total_PH + HAPConstruction.getQt() ;
		}
		
		double average_PH = total_PH/KalmanFilter.r_i_hat_list.size();
		double RHat = Math.abs(Cr - average_PH);
		
		this.setR_i_hat(RHat);
		
		
		
		//fusion
		double xi=0.0;
		double W = HAPConstruction.getQt()+this.getR_i_hat();
		
		double histWeight = 0; 
		double obsWeight = 0;
		
		if (W!=0){
			histWeight =this.getR_i_hat()/W;
			obsWeight = HAPConstruction.getQt()/W;
		}
		
	//	System.out.println(" this.getR_i_hat() "+this.getR_i_hat()+": hm.getQt() "+HAPConstruction.getQt()+": histWeight"+ histWeight+": obsWeight "+obsWeight+": hm.getqt() "+HAPConstruction.getqt()+": this.SPP.getSpp_xi() "+ScaledPhonePark.getSpp_xi());
		
		xi = (histWeight*HAPConstruction.getqt()) + (obsWeight *(ScaledPhonePark.getSpp_xi_uncapped()-0)); 
		//System.out.println("kalman "+ xi);
		
		if(xi>HistoricalModel.getN()){//capping
			xi=HistoricalModel.getN();
		}
		else if (xi<0.0){//capping
			xi=0.0;
		}
		return xi;
		
		
		
		
	}
	
	
	
	@SuppressWarnings("static-access")
	public double BoVersionOfKalmanFilter(){
		if (this.r_i_hat_list.size()>=h){
			this.r_i_hat_list.remove(0);
			this.Q_i_hat_list.remove(0);
		}
		this.setR_i_hat(SPP.getSpp_xi()-(hm.getqt()));
		this.r_i_hat_list.add(this.getR_i_hat());//save in r i hat list
		this.Q_i_hat_list.add(hm.getQt());
		System.out.println("r_i_hat_list size : "+r_i_hat_list.size());
		System.out.println("r_i_hat_list : "+r_i_hat_list.toString());
		//compute rhat
		double total_r_i = 0;
		for (int index=0;index<this.r_i_hat_list.size();index++){
			total_r_i = total_r_i +this.r_i_hat_list.get(index);
		}
		double rHat = total_r_i/r_i_hat_list.size();
		//this.set
		
		//compute RHat
		double Cr;
		if(r_i_hat_list.size()==1){
			Cr = (this.getR_i_hat()-rHat)*(this.getR_i_hat()-rHat);
		}
		else {
			double total_Cr = 0;
			for(int index=0;index<this.r_i_hat_list.size();index++){
				total_Cr = total_Cr + (this.getR_i_hat()-rHat)*(this.getR_i_hat()-rHat);
			}
			Cr = total_Cr/(this.r_i_hat_list.size()-1);
		}
		
		//then compute sigma(PH^2)/N
		
		double total_PH = 0;
		for(int index=0;index<this.r_i_hat_list.size();index++){
			total_PH = total_PH + hm.getQt() ;
		}
		
		double average_PH = total_PH/this.r_i_hat_list.size();
		double RHat = Math.abs(Cr - average_PH);
		
		this.setR_i_hat(RHat);
		
		
		
		//fusion
		double xi=0.0;
		double W = hm.getQt()+this.getR_i_hat();
		double histWeight = this.getR_i_hat()/W;
		double obsWeight = hm.getQt()/W;
		
		System.out.println(" this.getR_i_hat() "+this.getR_i_hat()+": hm.getQt() "+hm.getQt()+": histWeight"+ histWeight+": obsWeight "+obsWeight+": hm.getqt() "+hm.getqt()+": this.SPP.getSpp_xi() "+this.SPP.getSpp_xi());
		
		xi = (histWeight*hm.getqt()) + (obsWeight *(this.SPP.getSpp_xi()-rHat)); 
		System.out.println("kalman "+ xi);
		
		if(xi>m.getN()){//capping
			xi=m.getN();
		}
		else if (xi<0.0){//capping
			xi=0.0;
		}
		return xi;
		
		
		
		
	}
	
	
	public void updateTheErrorsUsingALMF(){
		
		if (r_i_hat_list.size()==0){
			//------------------------------ALMF--------------------------
			this.setR_i_hat(ScaledPhonePark.getSpp_xi()-(hm.getqt()));
			setrt(this.getR_i_hat());
			setRt(Math.pow(KalmanFilter.getrt(), 2));
			KalmanFilter.r_i_hat_list.add(this.getR_i_hat());//save in r i hat list
			KalmanFilter.Q_i_hat_list.add(HAPConstruction.getQt());
			//this.p_i_list.add(this.getP_i());
			//----------------------------------------------------------
			return;
		}
		
		this.setR_i_hat(ScaledPhonePark.getSpp_xi()-(hm.getqt()));
		double tempsub = (this.getR_i_hat()- (double)r_i_hat_list.get(0));
		double local_r_i = getrt()+ ((1/KalmanFilter.r_i_hat_list.size())*tempsub);
		KalmanFilter.setrt(local_r_i);
		//---------temp vars---------------
		int h_minus_1 = KalmanFilter.r_i_hat_list.size()-1; 
		if(h_minus_1 !=0){
			double tempvar1 = Math.pow((this.getR_i_hat()-getrt()),2);
			double tempvar2 = Math.pow(((double)KalmanFilter.r_i_hat_list.get(0)-getrt()),2);
			double tempvar3 = Math.pow((this.getR_i_hat()-(double)KalmanFilter.r_i_hat_list.get(0)),2);
			//double temptempvar4 = Math.pow((double)this.p_i_list.get(0),2);
			double tempvar4 =  (double) KalmanFilter.Q_i_hat_list.get(0);
			//double temptempvar5 = Math.pow((double)this.getP_i(),2);
			double tempvar5 =  HAPConstruction.getQt();//hm.getqt()
			//-----------------------
			double tempa = (1/(h_minus_1))* ((tempvar1 - tempvar2));
			double tempb = (1/KalmanFilter.r_i_hat_list.size())* tempvar3;
			double tempc = (h_minus_1/KalmanFilter.r_i_hat_list.size())* (tempvar4-tempvar5);
			double possible_R_i = (getRt()+ tempa + tempb + (tempc));//(1/this.r_i_hat_list.size())*(Math.pow((this.getR_i_hat()-(double)this.r_i_hat_list.get(0)), 2)) + ((this.r_i_hat_list.size()-1)/this.r_i_hat_list.size()) * (( (Math.pow((double)this.p_i_list.get(0), 2))* (double)this.r_i_hat_list.get(0))-(Math.pow(this.getP_i(), 2) * this.getQ_i()))   )));


			if(possible_R_i<0){
				setRt(Math.abs(possible_R_i));
			}
			else {
				setRt(possible_R_i);
			}
		}
		else {
			//this.setRt(getRt());
		}


		int test=0;

		// maintain the sliding window of size h
		if (KalmanFilter.r_i_hat_list.size()>=h){
			KalmanFilter.r_i_hat_list.remove(0);
			KalmanFilter.Q_i_hat_list.remove(0);
			//this.p_i_list.remove(0);

			KalmanFilter.r_i_hat_list.add(this.getR_i_hat());//save in r i hat list
			KalmanFilter.Q_i_hat_list.add(HAPConstruction.getQt());
			//this.p_i_list.add(this.getP_i());
		}
		else if (KalmanFilter.r_i_hat_list.size()<h){
			//this.p_i_list.add(this.getP_i());
			KalmanFilter.r_i_hat_list.add(this.getR_i_hat());//save in r i hat list
			KalmanFilter.Q_i_hat_list.add(HAPConstruction.getQt());

		}

	}
	
	
	public double getKalman_estimation_or_kalman_xi() {
		return kalman_estimation_or_kalman_xi;
	}

	public void setKalman_estimation_or_kalman_xi(
			double kalman_estimation_or_kalman_xi) {
		this.kalman_estimation_or_kalman_xi = kalman_estimation_or_kalman_xi;
	}

	public double getObservation_residual() {
		return observation_residual;
	}

	public void setObservation_residual(double observation_residual) {
		this.observation_residual = observation_residual;
	}

	public double getKalman_gain() {
		return kalman_gain;
	}

	public void setKalman_gain(double kalman_gain) {
		this.kalman_gain = kalman_gain;
	}
	public static double getrt() {
		return rt;
	}

	public static void setrt(double rt) {
		KalmanFilter.rt = rt;
	}

	public static double getRt() {
		return Rt;
	}

	public static void setRt(double rt) {
		Rt = rt;
	}
	
	public double getR_i_hat() {
		return r_i_hat;
	}

	public int getH() {
		return h;
	}

	public void setH(int h) {
		KalmanFilter.h = h;
	}

	public void setR_i_hat(double r_i_hat) {
		this.r_i_hat = r_i_hat;
	}

	public int getX_hat() {
		return x_hat;
	}

	public void setX_hat(int x_hat) {
		this.x_hat = x_hat;
	}



}
