package com.parking.main;

import java.io.FileWriter;
import java.io.PrintWriter;
import java.sql.ResultSet;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Random;
import com.parking.HAPEstimation.HAPConstruction;
import com.parking.HAPEstimation.Utilities;

/**
 * @author leon stenneth, lstennethATgmail.com
 *
 */
//this test uses the rmse of HAP and true mean
public class Experiment {
	
	private HAPConstruction haptest;
	private Random randomizer, random;
	private Utilities utility;
	private static int global_map_index = 0;
	@SuppressWarnings("deprecation")
	private Time start_of_permitted_parking_period= new Time(14, 15, 0); // start of;
	@SuppressWarnings("deprecation")
	private Time end_of_permitted_parking_period =new Time(13, 15, 0/**14, 40, 0*/); // end of permitted
	private static int permitted_period_count=0;
	private static int permitted_period_count_from_PAE=0;
	private ArrayList <Integer> permitted_index_list;
	PrintWriter out;// = new PrintWriter(new FileWriter("C:\\Program Files\\apache-tomcat-6.0.33\\lib\\27\\HAP_RMSE_RESULTS_"+new Date()+".txt",true),true);
	PrintWriter out2, hapOut;

	//328002 -Beale St (2-98)
	//612032  Polk street(300-398 ), operational-12
	// 380002 Davis St (2-98), operational 9, mean avl 5.4062155086842045
	// 440171 mean - avg x_i 5.294965436388848	
	private static int block_id = 612032; //set the file with hapmean
	private static int num_operational_sensors=12;
	private static int num_of_experiments = 1;
	
	public Experiment() {
		try {
			random = new Random();
			randomizer = new Random();
			haptest = new HAPConstruction();
			utility = new Utilities();
			permitted_index_list = new ArrayList <Integer>();
			permitted_index_list.add(0);//bootstrap
			out = new PrintWriter(new FileWriter("HAPRMSE.txt",true),true);
			out2 = new PrintWriter(new FileWriter("HAPAVG_XI.txt",true),true);
			hapOut = new PrintWriter(new FileWriter("HAPMEANANDVAR"+block_id+".txt",true),true);
		}

		catch(Exception e){
			e.printStackTrace();
		}
	}

	public static void main(String args[]) {
		Experiment e = new Experiment();
		double avg_rmse = 0.0,local_rmse=0.0, sum_rmse=0.0, sum_x_i=0.0;		
		for(double penetration_ratio=0.01;penetration_ratio<=0.01;penetration_ratio+=0.49){
			e = new Experiment();

			e.out.println("block id: "+block_id+"   penetration ratio: "+penetration_ratio);
			
			for(double false_negtive_prob=0.0;false_negtive_prob<=0.25;false_negtive_prob+=0.05) {
				e = new Experiment();
				double false_postive_prob=0;
				//for(double false_negtive_prob=0.0;false_negtive_prob<=0.01;false_negtive_prob+=0.05) {
					avg_rmse = 0.0;local_rmse=0.0; sum_rmse=0.0;sum_x_i=0;
					for(int index=0;index<num_of_experiments;index++){
						e = new Experiment();
						
						e.haptest.getHap().setStreet_block_id(block_id);
						e.haptest.getHap().setStartTimeFrameForValidation("2012-04-10");// 2012-04-10when
						e.haptest.getHap().setEndTimeFrameForValidation("2012-08-11");
						e.haptest.getHap().setN(num_operational_sensors);
						
						e.haptest.getHap().setB(penetration_ratio);
						
						e.haptest.getHap().setFn(false_negtive_prob);
						e.haptest.getHap().setFp(false_postive_prob);	


						local_rmse = e.computeHAPPerSecond(index);

						sum_rmse = sum_rmse+local_rmse;

					}

					avg_rmse = sum_rmse/num_of_experiments;
					e.out.print("b= " + penetration_ratio + ", fp= " + false_postive_prob + ", fn= " + false_negtive_prob + ", ");
					e.out.print("rms= " + avg_rmse);
					e.out.println(",");
					e.out.close();

				}
			}

		}

	//}



	public String runHAPFromPAE(double penetration_ratio,double fp,double fn,int hour, int min,int permitted_count_from_HAP) {
		permitted_period_count_from_PAE = permitted_count_from_HAP;
		//Experiment e = new Experiment();
		this.randomizer = new Random();
		System.out.println("hour "+ hour+ " minute "+min);
		int num_of_experiments = 1;
		
		double avg_mean = 0.0,local_mean=0.0, sum_mean=0.0, avg_variance = 0.0,local_variance=0.0, sum_variance=0.0;

		int block_id = 612032; 
		num_operational_sensors = 12;// e.haptest.getHap().resetNFromDataBase(block_id);
		this.haptest.getHap().setN(num_operational_sensors)	;		
		for(int index=0;index<num_of_experiments;index++){
			//e = new Experiment();
			this.haptest.getHap().setStreet_block_id(block_id);



			this.haptest.getHap().setStartTimeFrameForValidation("2012-03-07");// when
			this.haptest.getHap().setEndTimeFrameForValidation("2012-04-08");

			//e.haptest.getHap().setStartTimeFrameForValidation("2012-03-07");// when
			//e.haptest.getHap().setEndTimeFrameForValidation("2012-04-08");
			//e.haptest.getHap().setStartTimeFrameForHistory("2012-03-06");
			//e.haptest.getHap().setEndTimeFrameForHistory("2012-04-25");


			this.haptest.getHap().setB(penetration_ratio);
			System.out.println(" Experiment: penetration ratio"+this.haptest.getHap().getB());
			//this.haptest.getHap().setPsd_accuracy(psd_accuracy);
			this.haptest.getHap().setFn(fn);
			this.haptest.getHap().setFp(fp);	
			String meanWithVariance = this.computeHAPForPAE(hour, min);
			local_mean = Double.parseDouble(meanWithVariance.split(":")[0]); //local RMSE is mean total lazy coding
			local_variance = Double.parseDouble(meanWithVariance.split(":")[1]); //local RMSE is mean total lazy coding

			sum_mean = sum_mean+local_mean;
			sum_variance = sum_variance+local_variance;

		}

		//avg_x_i = sum_x_i/num_of_experiments;
		avg_mean = sum_mean/num_of_experiments;
		avg_variance = sum_variance/num_of_experiments;

		//computing the varince 


		return avg_mean+":"+avg_variance;
	}
	public String computeHAPForPAE(int candidateHour, int candidateMinute) {
		permitted_period_count = 0;
		ResultSet rs = this.haptest.getHap().getValidationPieceOfDataFromDB();
		boolean startup = true;

		// per minute validation
		try {
			while (rs.next()) {

				// /////////////////////////////////////////////////////////////////////////////////////
				// ////////computing the temporal property of the incoming
				// signal and query the db /////
				// ////////for the historical mean and
				// variance/////////////////////////////////////////

				this.haptest.getHap().setHistory_start_hour(rs.getInt(3));
				this.haptest.getHap().setHistory_start_minute(rs.getInt(5));
				this.haptest.getHap().setHistory_start_second(rs.getInt(6));

				// increment by 1 minute
				if (rs.getInt(5) < 59) { // if not the 59th minute
					this.haptest.getHap().setHistory_end_hour(rs.getInt(3));
					this.haptest.getHap().setHistory_end_minute(
							rs.getInt(5) + 1);
					this.haptest.getHap().setHistory_end_second(rs.getInt(6));
				} else {
					this.haptest.getHap().setHistory_end_hour(rs.getInt(3) + 1);
					this.haptest.getHap().setHistory_end_minute(
							0 + (rs.getInt(5) - 59));
					this.haptest.getHap().setHistory_end_second(rs.getInt(6));

				}
				// ///////////////////////////////////////////////////////////////////
				// ////////end setting the time period for building the/////////////
				////////////////////////////////history///////////////////////////////


				//this.haptest.computeMeanAndVarianceFromHistoryForATimePeriod();




				// setting the true parking availability and observed
				// availability, at cold start this should be N
				int current_xi = rs.getInt(2);
				if (startup) {
					this.haptest.getHap().setXi(rs.getInt(2));
					this.haptest.getHap().setAi(rs.getInt(2));
					//this.haptest.getHap().setXi(this.haptest.getHap().getN());
					//this.haptest.getHap().setAi(this.haptest.getHap().getN());
					startup = false;
					//continue;
				}
				// not cold start or start of permitted period
				else {
					double a = 0;
					if(this.startOfPermittedPeriod(rs.getTimestamp(4))/**&&rs.getInt(2)==10*/){
						//this.haptest.getHap().setXi(this.haptest.getHap().getN());
						//this.haptest.getHap().setAi(this.haptest.getHap().getN());

						this.haptest.getHap().setXi(rs.getInt(2));
						this.haptest.getHap().setAi(rs.getInt(2));
						current_xi=rs.getInt(2);


						permitted_index_list.add(rs.getRow());


					}

					if (this.haptest.getHap().getXi() > current_xi/**
					 * 
					 * 
					 * 
					 * &&(this.haptest.getHap().getAi()!=0)
					 */
							) { // if people parked
						double iteration_count = this.haptest.getHap().getXi() - current_xi;
						int fpCount=0;
						for (int k = 0; k < iteration_count; k++) {
							a = randomizer.nextDouble();// generate a random
							// number between 0 and 1
							double probability = this.haptest.getHap().getB()
									* (1-this.haptest.getHap().getFn())/**this.haptest.getHap().getPsd_accuracy()*/;
							if (a <= probability) {
								this.haptest.decreaseParkingAvailability();
								fpCount++;

							}
						}
						//generate count number of false positive reports count = negBin(fpCount, fp)
						int negBinomial = Utilities.NBRandom(fpCount, this.haptest.getHap().getFp(), new Random());
						for(int count=0;count< negBinomial ; count++){
							this.generateFalsePositive("decrease");//generate false positives
						}
						
						

					} 

					else if (this.haptest.getHap().getXi() < current_xi/**
					 * 
					 * 
					 * 
					 * &&(this
					 * .haptest.getHap().getAi()!=this.haptest.getHap().getN())
					 */
							) { // if people deparked
						double iteration_count =current_xi - this.haptest.getHap()
								.getXi();
						int fpCount=0;
						for (int j = 0; j < iteration_count; j++) {
							a = randomizer.nextDouble();// generate a random
							// number between 0 and 1
							double probability = this.haptest.getHap().getB()
									* (1-this.haptest.getHap().getFn())/**this.haptest.getHap().getPsd_accuracy()*/;
							if (a <= (probability)) {
								this.haptest.increaseParkingAvailability();
								fpCount++;


								//capped hap
								/*if(this.haptest.getHap().getAi()>this.haptest.getHap().getN()){
									this.haptest.getHap().setAi(this.haptest.getHap().getN());
								}
								if(this.haptest.getHap().getAi()<0){
									this.haptest.getHap().setAi(0);
								}*/
							}
						}

						//generate count number of false positive reports count = negBin(fpCount, fp)
						int negBinomial = Utilities.NBRandom(fpCount, this.haptest.getHap().getFp(), new Random());
						for(int count=0;count< negBinomial ; count++){
							this.generateFalsePositive("increase");//generate false positives
						}
					}
					this.haptest.getHap().setXi(current_xi);

				}


				/*if (this.haptest.getHap().getAi()==0.0){
					continue;
				}*/
				this.processUtilities2(rs.getTimestamp(4));

				/*System.out.println("true:" + this.haptest.getHap().getXi());
				System.out.println("HAP:" + this.haptest.getHap().getAi());
				System.out.println("historical mean: " + this.haptest.getqt()
						+ " var: " + this.haptest.getQt());
				System.out.println("----------------------");*/

			} // end while

			rs.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.utility.convertTimeMapofStringToDoubles();

		String historic_mean = this.computeHistoricMeanUsingHAPForPAE(candidateHour, candidateMinute);
		//final_rmse
		System.out.println("total permitted periods   "+permitted_period_count);

		return historic_mean;
	}


	public void cap (){
		//capped hap
		if(this.haptest.getHap().getAi()>this.haptest.getHap().getN()){
			this.haptest.getHap().setAi(this.haptest.getHap().getN());
		}
		if(this.haptest.getHap().getAi()<0){
			this.haptest.getHap().setAi(0.0);
		}
	
	}
	@SuppressWarnings("deprecation")
	public Boolean startOfPermittedPeriod(Timestamp t){
		Boolean start_of_permitted_period=false;
		if(t.getHours()==this.end_of_permitted_parking_period.getHours()&&t.getMinutes()>this.end_of_permitted_parking_period.getMinutes()){   // 7:45
			start_of_permitted_period=true;
			permitted_period_count++;
			return start_of_permitted_period;
		}

		else if(t.getHours()==this.start_of_permitted_parking_period.getHours()&&t.getMinutes()<this.start_of_permitted_parking_period.getMinutes()){ //8:15
			start_of_permitted_period=true;
			permitted_period_count++;
			return start_of_permitted_period;
		}

		return start_of_permitted_period;
	}

	ArrayList <Integer> equalTimePoints(ArrayList<Double> list, double val){
		ArrayList <Integer> recs = new ArrayList <Integer>();
		
		for(int index=0;index<list.size();index++){
			if(list.get(index)==val){
				
				recs.add(index);
				
			}
		}
		return recs;
	}

	public double computeHAP() { //At change point...not per second
		permitted_period_count = 0;
		ResultSet rs = this.haptest.getHap().getValidationPieceOfDataFromDB();
		boolean startup = true;

		// per minute validation
		try {
			while (rs.next()) {

				// /////////////////////////////////////////////////////////////////////////////////////
				// ////////computing the temporal property of the incoming
				// signal and query the db /////
				// ////////for the historical mean and
				// variance/////////////////////////////////////////

				this.haptest.getHap().setHistory_start_hour(rs.getInt(3));
				this.haptest.getHap().setHistory_start_minute(rs.getInt(5));
				this.haptest.getHap().setHistory_start_second(rs.getInt(6));

				// increment by 1 minute
				if (rs.getInt(5) < 59) { // if not the 59th minute
					this.haptest.getHap().setHistory_end_hour(rs.getInt(3));
					this.haptest.getHap().setHistory_end_minute(
							rs.getInt(5) + 1);
					this.haptest.getHap().setHistory_end_second(rs.getInt(6));
				} else {
					this.haptest.getHap().setHistory_end_hour(rs.getInt(3) + 1);
					this.haptest.getHap().setHistory_end_minute(
							0 + (rs.getInt(5) - 59));
					this.haptest.getHap().setHistory_end_second(rs.getInt(6));

				}
				// ///////////////////////////////////////////////////////////////////
				// ////////end setting the time period for building the/////////////
				////////////////////////////////history///////////////////////////////


				this.haptest.computeMeanAndVariance();




				// setting the true parking availability and observed
				// availability, at cold start this should be N
				int current_xi = rs.getInt(2);
				if (startup) {
					this.haptest.getHap().setXi(current_xi);
					this.haptest.getHap().setAi(current_xi);
					startup = false;
					//continue;
				}
				// not cold start or start of permitted period
				else {
					double a = 0;


					if(this.startOfPermittedPeriod(rs.getTimestamp(4))/**&&rs.getInt(2)==10*/){
						this.haptest.getHap().setXi(rs.getInt(2));
						this.haptest.getHap().setAi(rs.getInt(2));
						current_xi=rs.getInt(2);
						permitted_index_list.add(rs.getRow());
					}

					if (this.haptest.getHap().getXi() > current_xi/**
					  &&(this.haptest.getHap().getAi()!=0)
					 */
							) { // if people parked
						double iteration_count = this.haptest.getHap().getXi() - current_xi;
						int fpCount=0;
						for (int k = 0; k < iteration_count; k++) {
							a = randomizer.nextDouble();// generate a random
							// number between 0 and 1
							double probability = this.haptest.getHap().getB()
									* (1-this.haptest.getHap().getFn())/**this.haptest.getHap().getPsd_accuracy()*/;
							if (a <= probability) {
								this.haptest.decreaseParkingAvailability();
								fpCount++;
							}

						}

						//generate count number of false positive reports count = negBin(fpCount, fp)
						int negBinomial = Utilities.NBRandom(fpCount, this.haptest.getHap().getFp(), random);
						for(int count=0;count< negBinomial ; count++){
							this.generateFalsePositive("decrease");//generate false positives
						}
					} 





					else if (this.haptest.getHap().getXi() < current_xi/**
					 * 
					 * 
					 * 
					 * &&(this
					 * .haptest.getHap().getAi()!=this.haptest.getHap().getN())
					 */
							) { // if people deparked
						double iteration_count =current_xi - this.haptest.getHap()
								.getXi();
						int fpCount = 0;
						for (int j = 0; j < iteration_count; j++) {
							a = randomizer.nextDouble();// generate a random
							// number between 0 and 1
							double probability = this.haptest.getHap().getB()
									* (1-this.haptest.getHap().getFn())/**this.haptest.getHap().getPsd_accuracy()*/;
							if (a <= (probability)) {
								this.haptest.increaseParkingAvailability();
								fpCount++;
							}
						}

						//generate count number of false positive reports count = negBin(fpCount, fp)
						int negBinomial = Utilities.NBRandom(fpCount, this.haptest.getHap().getFp(), random);
						for(int count=0;count< negBinomial ; count++){
							this.generateFalsePositive("increase");//generate false positives
						}
					}
					this.haptest.getHap().setXi(current_xi);

				}

				/*if (this.haptest.getHap().getAi()==0.0){
					continue;
				}*/
				this.processUtilities(rs.getTimestamp(4));

				System.out.println("true:" + this.haptest.getHap().getXi());
				System.out.println("HAP:" + this.haptest.getHap().getAi());
				System.out.println("historical mean: " + this.haptest.getqt()
						+ " var: " + this.haptest.getQt());
				System.out.println("----------------------");

			} // end while

			rs.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.utility.convertTimeMapofStringToDoubles();

		double rmse = this.computeRMSE();
		//final_rmse
		System.out.println("total permitted periods   "+permitted_period_count);

		return rmse;
	}


	@SuppressWarnings("deprecation")
	public double computeHAPPerSecond(int experimentNum) {
		Boolean permittedPeriod = false;
		permitted_period_count = 0;
		ResultSet rs = this.haptest.getHap().getValidationPieceOfDataFromDB();
		HashMap <java.sql.Timestamp, Integer> avlMap = new HashMap<java.sql.Timestamp, Integer>();

		boolean coldStart = true;


		// per minute validation
		try {
			rs.next();
			Calendar cal= Calendar.getInstance();
			cal.setTime(rs.getTimestamp(4));//rs first date
			while(rs.next()){
				avlMap.put(rs.getTimestamp(4), rs.getInt(2));
			}
			
			rs.last();//move curser to last row
			Calendar endCal= Calendar.getInstance();
			endCal.setTime(rs.getTimestamp(4));
			while (cal.getTime().before(endCal.getTime())) {

				// /////////////////////////////////////////////////////////////////////////////////////
				// ////////computing the temporal property of the incoming
				// signal and query the db /////
				// ////////for the historical mean and
				// variance/////////////////////////////////////////

				this.haptest.getHap().setHistory_start_hour(cal.getTime().getHours());
				this.haptest.getHap().setHistory_start_minute(cal.getTime().getMinutes());
				this.haptest.getHap().setHistory_start_second(cal.getTime().getSeconds());

				// increment by 1 second..taking care of border line cases
				if (cal.getTime().getMinutes() < 59) { // if not the 59th second
					this.haptest.getHap().setHistory_end_hour(cal.getTime().getHours());
					this.haptest.getHap().setHistory_end_minute(
							cal.getTime().getMinutes()+1);
					//this.haptest.getHap().setHistory_end_second(cal.getTime().getSeconds()+1);
				} 
				else {
					this.haptest.getHap().setHistory_end_hour(cal.getTime().getHours()+1);
					//this.haptest.getHap().setHistory_end_minute(cal.getTime().getMinutes()+1
					//	);
					this.haptest.getHap().setHistory_end_minute(0 + (cal.getTime().getMinutes() - 59));

				}
				// ///////////////////////////////////////////////////////////////////
				// ////////end setting the time period for building the/////////////
				////////////////////////////////history///////////////////////////////

				

				//this.haptest.computeMeanAndVariance();

				int current_xi = getAvailability(cal, avlMap);
					double a = 0;

					if(coldStart){
						this.haptest.getHap().setXi(current_xi);
						this.haptest.getHap().setAi(current_xi);
						coldStart=false;
					}

					permittedPeriod=false;
					if(this.startOfPermittedPeriod(new Timestamp(cal.getTimeInMillis())) /**&&rs.getInt(2)==10*/){
						this.haptest.getHap().setXi(current_xi);
						this.haptest.getHap().setAi(current_xi);
						permittedPeriod = true;
						if(cal.getTime().getMinutes()==59){ //tryna to make it once per day
							permitted_index_list.add(0);
							System.out.println("restricted period "+cal.getTime().toString());
						}
					}

					else if (this.haptest.getHap().getXi() > current_xi) { // if people parked
						double iteration_count = this.haptest.getHap().getXi() - current_xi;
						int fpCount=0;
						for (int k = 0; k < iteration_count; k++) {
							a = randomizer.nextDouble();// generate a random
							// number between 0 and 1
							double probability = this.haptest.getHap().getB()
									* (1-this.haptest.getHap().getFn())/**this.haptest.getHap().getPsd_accuracy()*/;
							if (a <= probability) {
								this.haptest.decreaseParkingAvailability();
								fpCount++;
								this.cap();
							}

						}

						//generate count number of false positive reports count = negBin(fpCount, fp)
						int negBinomial = Utilities.NBRandom(fpCount, this.haptest.getHap().getFp(), random);
						for(int count=0;count< negBinomial ; count++){
							this.generateFalsePositive("decrease");//generate false positives
							this.cap();
						}
					} 
					
					else if (this.haptest.getHap().getXi() < current_xi) { // if people deparked
						double iteration_count =current_xi - this.haptest.getHap()
								.getXi();
						int fpCount = 0;
						for (int j = 0; j < iteration_count; j++) {
							a = randomizer.nextDouble();// generate a random
							// number between 0 and 1
							double probability = this.haptest.getHap().getB()
									* (1-this.haptest.getHap().getFn())/**this.haptest.getHap().getPsd_accuracy()*/;
							if (a <= (probability)) {
								this.haptest.increaseParkingAvailability();
								fpCount++;
								this.cap();
							}
						}

						//generate count number of false positive reports count = negBin(fpCount, fp)
						int negBinomial = Utilities.NBRandom(fpCount, this.haptest.getHap().getFp(), random);
						for(int count=0;count< negBinomial ; count++){
							this.generateFalsePositive("increase");//generate false positives
							this.cap();
						}
					}
					
					
				this.haptest.getHap().setXi(current_xi);

				this.processUtilities(new Timestamp(cal.getTimeInMillis()));
					

				/*System.out.println("true:" + this.haptest.getHap().getXi());
				System.out.println("HAP:" + this.haptest.getHap().getAi());
				System.out.println("historical mean: " + this.haptest.getqt()
						+ " var: " + this.haptest.getQt());
				System.out.println(cal.getTime().toString()+ "----------------------");
				 */

				cal.add(Calendar.MINUTE, 1);
			} // end while

			rs.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.utility.convertTimeMapofStringToDoubles();

		double rmse = this.computeRMSEPerSecond(experimentNum);
		//final_rmse
		System.out.println("total permitted periods   "+permitted_index_list.size());

		return rmse;
	}

	public int getAvailability(Calendar cal, HashMap<Timestamp, Integer> avlMap) {
		
		return avlMap.get(this.closest(new Timestamp(cal.getTimeInMillis()),new ArrayList<Timestamp>(avlMap.keySet())));
	}

	public Timestamp closest(Timestamp cal, List<Timestamp> in) {
		Collections.sort(in);
		long min = Long.MAX_VALUE;
		Timestamp closest = in.get(0);

		for (Timestamp v : in) {
			final long diff = cal.getTime()-v.getTime() ;

			if (diff < min && diff>0) {
				//System.out.println("feeeeeeeeee");
				min = diff;
				closest = v;
			}

			if(v.getTime()>cal.getTime()){ //since it is sorted
				break;
			}
		}

		//System.out.println(cal.toString()+" closest to "+closest.toString());
		return closest;
	}



	public void processUtilities(Timestamp t) {
		///utility = new Utilities();
		String hourMin =(t.toString().split(" ")[1]).split("\\.")[0]; 
		this.utility.getTime_map().add(hourMin);
		this.utility.getHAP_list().add(this.haptest.getHap().getAi());
		this.utility.getTrue_avl_list().add(this.haptest.getHap().getXi());
		//this.utility.getHistorical_mean_list().add(this.haptest.getqt());
		//this.utility.getHistorical_variance_list().add(this.haptest.getQt());
		
		//System.out.println(hourMin +"HAP:"+this.haptest.getHap().getAi()+" TRUE:"+this.haptest.getHap().getXi());

		
	}

	public void processUtilities2(Timestamp  t) {
		///utility = new Utilities();
		this.utility.getTime_map().add(
				(t.toString().split(" ")[1]).split("\\.")[0]);
		this.utility.getHAP_list().add(this.haptest.getHap().getAi());


	}


	@SuppressWarnings("deprecation")
	public String computeHistoricMeanUsingHAPForPAE(int candidateHour, int candidateMinute) {
		double mean_variance=0.0;
		double mean_ai = 0;
		double sum_variance = 0.0; //equation 5.2
		double sum_ai = 0.0;
		Time start_of_permitted_period = new Time(14, 15, 0); // start of
		Time end_of_permitted_period = new Time(13, 40, 0); // end of permitted

		Calendar calendar = Calendar.getInstance();

		calendar.setTime(start_of_permitted_period);

		while (!calendar.getTime().toString()
				.contains(end_of_permitted_period.toString()) /**&&(calendar.getTime().toString().contains(new Time (candidateHour,candidateMinute,0).toString()))*/) { // permitted

			global_map_index = 0;
			for(int permitted_period=0;permitted_period<permitted_index_list.size();permitted_period++){
				if(calendar.getTime().toString().contains(new Time (candidateHour,candidateMinute,0).toString())) {
					if((permitted_period+1)<permitted_index_list.size()){
						String calendar_to_string = new Date(calendar.getTimeInMillis()).getHours()+":"+new Date(calendar.getTimeInMillis()).getMinutes();
						int location = this.closestTimePoint(this.utility.getTime_map_as_doubles(), this.utility.convertTimeStringToDouble(calendar_to_string), permitted_index_list.get(permitted_period), permitted_index_list.get(permitted_period+1));
						//if (location>= permitted_index_list.get(permitted_period)&&location<=permitted_index_list.get(permitted_period+1)){
						sum_ai = sum_ai + this.utility.getHAP_list().get(location);
						//System.out.println("HERE>>>>>>>>>>>>>>>>"+sum_ai);
						if(!(this.utility.getHAP_list().get(location)==0.0)){
							global_map_index++;
						}
					}
				}
			}

			//mean_ai = sum_ai / (permitted_index_list.size()-1); //HAP
			if(global_map_index!=0)
				mean_ai = sum_ai / permitted_period_count_from_PAE; //HAP

			//System.out.println("HAP >>> sum_ai "+sum_ai);
			//System.out.println("HAP >>> mean_ai "+mean_ai);

			//sum_ai = 0;


			calendar.add(Calendar.MINUTE, 1);
		}
		System.out.println("HAP >>> permitted list size: "+permitted_index_list.size());
		System.out.println("HAP sum a i : "+sum_ai);

		calendar.setTime(start_of_permitted_period);

		while (!calendar.getTime().toString()
				.contains(end_of_permitted_period.toString()) /**&&(calendar.getTime().toString().contains(new Time (candidateHour,candidateMinute,0).toString()))*/) { // permitted

			global_map_index = 0;
			for(int permitted_period=0;permitted_period<permitted_index_list.size();permitted_period++){
				if(calendar.getTime().toString().contains(new Time (candidateHour,candidateMinute,0).toString())) {
					//System.out.println(calendar.getTime().toString()+"-"+new Time (candidateHour,candidateMinute,0));
					if((permitted_period+1)<permitted_index_list.size()){
						String calendar_to_string = new Date(calendar.getTimeInMillis()).getHours()+":"+new Date(calendar.getTimeInMillis()).getMinutes();
						int location = this.closestTimePoint(this.utility.getTime_map_as_doubles(), this.utility.convertTimeStringToDouble(calendar_to_string), permitted_index_list.get(permitted_period), permitted_index_list.get(permitted_period+1));
						//if (location>= permitted_index_list.get(permitted_period)&&location<=permitted_index_list.get(permitted_period+1)){
						//sum_variance = sum_variance+ Math.pow((this.utility.getHAP_list().get(location) - mean_ai),2);
						if (!(this.utility.getHAP_list().get(location)==0.0)) {
							global_map_index++;
						}
					}
				}
			}
			if(global_map_index!=0)
				mean_variance = sum_variance / permitted_period_count_from_PAE; //HAP
			//this.haptest.setQt(mean_variance);
			//sum_variance = 0;

			calendar.add(Calendar.MINUTE, 1);
		}
		//end variance computation

		System.out.println("from HAP mean_ai , mean_variance "+mean_ai +":"+mean_variance);
		return mean_ai +":"+mean_variance;
	}


	public double computeVariance(double mean){
		double variance = 0.0;




		return variance;
	}

	@SuppressWarnings("deprecation")
	public Double computeRMSE() {
		double final_rmse = 0.0;
		double mean_xi_across_time = 0.0;
		int total_time_instance=0;
		double sum_ai = 0.0, sum_xi = 0.0, sum_qi = 0.0, sum_Qi = 0.0;
		double rmse=0.0;
		Time start_of_permitted_period = new Time(14, 15, 0); // start of
		Time end_of_permitted_period = new Time(13, 40, 0); // end of permitted

		Calendar calendar = Calendar.getInstance();

		calendar.setTime(start_of_permitted_period);

		while (!calendar.getTime().toString()
				.contains(end_of_permitted_period.toString())) { // permitted
			//Iterator itr = permitted_index_list.iterator();
			global_map_index = 0;
			for(int permitted_period=0;permitted_period<permitted_index_list.size();permitted_period++){
				if((permitted_period+1)<permitted_index_list.size()){
					String calendar_to_string = new Date(calendar.getTimeInMillis()).getHours()+":"+new Date(calendar.getTimeInMillis()).getMinutes();
					int location = this.closestTimePoint(this.utility.getTime_map_as_doubles(), this.utility.convertTimeStringToDouble(calendar_to_string), permitted_index_list.get(permitted_period), permitted_index_list.get(permitted_period+1));
					//if (location>= permitted_index_list.get(permitted_period)&&location<=permitted_index_list.get(permitted_period+1)){
					sum_ai = sum_ai + this.utility.getHAP_list().get(location);
					sum_xi = sum_xi
							+ this.utility.getTrue_avl_list().get(location);
					sum_qi = sum_qi
							+ this.utility.getHistorical_mean_list().get(location);
					sum_Qi = sum_Qi
							+ this.utility.getHistorical_variance_list().get(
									location);

					/*//for the question that Bo asked. 
					sum_variance = sum_variance+Math.pow((this.utility.getHistorical_mean_list().get(location)-this.utility.getHAP_list().get(location)),2);
					//end of Bo's question
					 * */

					global_map_index++;
					//}
				}
			}



			//double mean_xi = sum_xi / permitted_index_list.size(); //true
			double mean_qi = sum_qi / (permitted_index_list.size()-1); //true

			double mean_ai = sum_ai / (permitted_index_list.size()-1); //HAP



			//this is the value of qi in the experiment........




			/*// Bo's question
			double mean_variance = sum_variance/permitted_index_list.size();
			System.out.println("Bo's question and answer across permitted periods: var= "+mean_variance+" std_dev="+Math.sqrt(mean_variance));
			mean_variance_across_time = mean_variance_across_time+mean_variance ;
			//end of Bo's question
			 */			
			//rmse = rmse + Math.pow(((meanxi)-(mean_ai)),2);
			rmse = rmse + Math.pow(((mean_qi)-(mean_ai)),2);

			//mean_xi_across_time = mean_xi_across_time+mean_xi ;
			mean_xi_across_time = mean_xi_across_time+mean_qi ;



			total_time_instance++;

			sum_ai = 0.0;
			sum_xi = 0.0;
			sum_qi = 0.0;
			sum_Qi = 0.0;


			calendar.add(Calendar.MINUTE, 1);
		}


		/*//Bo's question
		mean_variance_across_time = mean_variance_across_time/total_time_instance;
		System.out.println("Bo's question and answer across permitted periods and across time: var= "+mean_variance_across_time+" std_dev="+Math.sqrt(mean_variance_across_time));
		//end of Bo's question
		 */		
		mean_xi_across_time = mean_xi_across_time/total_time_instance;
		rmse = rmse/total_time_instance;
		final_rmse = Math.sqrt(rmse);



		System.out.println("\n\ntotal time instance "+total_time_instance);
		System.out.println("avg x_i "+mean_xi_across_time);
		System.out.println("RMSE = "+final_rmse);

		////end of for loop


		/*this.out.print(final_rmse);
		this.out.print(",");*/


		return final_rmse;
	}

	@SuppressWarnings("deprecation")
	public Double computeRMSEPerSecond(int experimentNum) {
		
		
		double final_rmse = 0.0;
		double mean_xi_across_time = 0.0;
		int total_time_instance=0;
		int randomMeanSelection = 0;
		double sum_ai = 0.0, sum_xi = 0.0, sum_qi = 0.0, sum_Qi = 0.0;
		double rmse=0.0;
		ArrayList <Double>varianceList =  new ArrayList<Double>();
		Time start_of_permitted_period = new Time(14, 15, 0); // start of
		Time end_of_permitted_period = new Time(13, 15, 0); // end of permitted

		try {
			if(experimentNum==0){
				hapOut.println("fn:"+this.haptest.getHap().getFn()+"fp:"+this.haptest.getHap().getFp()+"b:"+this.haptest.getHap().getB());
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		Calendar calendar = Calendar.getInstance();

		calendar.setTime(start_of_permitted_period);
		
		
		while (!calendar.getTime().toString()
				.contains(end_of_permitted_period.toString())) { // permitted

			String calendar_to_string = new Date(calendar.getTimeInMillis()).getHours()+":"+new Date(calendar.getTimeInMillis()).getMinutes();
			ArrayList <Integer> locations = this.equalTimePoints(this.utility.getTime_map_as_doubles(), this.utility.convertTimeStringToDouble(calendar_to_string) );// permitted_index_list.get(permitted_period), permitted_index_list.get(permitted_period+1));
			
			global_map_index = 0;
			if(locations!=null){
				randomMeanSelection=0;
				varianceList= new ArrayList <Double>();
				
				for(int location:locations) {
					if( location<this.utility.getHAP_list().size()){

						sum_ai = sum_ai + this.utility.getHAP_list().get(location);
						varianceList.add(this.utility.getHAP_list().get(location));
						
						
						sum_xi = sum_xi
								+ this.utility.getTrue_avl_list().get(location);
						
						double meanRand = random.nextDouble();
						
						if(meanRand<0.5){
							sum_qi = sum_qi
								+ this.utility.getTrue_avl_list().get(location);
						
							randomMeanSelection++;
						}
						
						
						
						/*sum_Qi = sum_Qi
								+ this.utility.getHistorical_variance_list().get(
										location);*/
						
						/*System.out.println(calendar.getTime().toString());
						System.out.println(this.utility.convertTimeStringToDouble(calendar_to_string));
						System.out.println(this.utility.getTime_map_as_doubles().get(location)+"----"+sum_ai +"-----"+sum_xi+"\n---------------------");
						*/
						
						global_map_index++;
					}
					}
				

			}

			double mean_qi = sum_qi /randomMeanSelection; //mean
			//System.out.println("mean qi"+mean_qi);

			double mean_ai = sum_ai / (permitted_index_list.size()-1); //HAP
			//System.out.println("mean ai"+mean_ai);
			double mean_ai_var = this.utility.getVariance(varianceList); //HAP var
			
			
			try {
				if(experimentNum==0){
					hapOut.println(calendar.getTime().getHours()+":"+calendar.getTime().getMinutes()+","+mean_ai+","+mean_ai_var);
				}
			}	
			catch(Exception e){
				e.printStackTrace();
			}
			
			
			rmse = rmse + Math.pow(((mean_qi)-(mean_ai)),2);

			
			mean_xi_across_time = mean_xi_across_time+mean_qi ;



			total_time_instance++;

			sum_ai = 0.0;
			sum_xi = 0.0;
			sum_qi = 0.0;
			//sum_Qi = 0.0;


			calendar.add(Calendar.MINUTE, 1);
		}


		/*//Bo's question
		mean_variance_across_time = mean_variance_across_time/total_time_instance;
		System.out.println("Bo's question and answer across permitted periods and across time: var= "+mean_variance_across_time+" std_dev="+Math.sqrt(mean_variance_across_time));
		//end of Bo's question
		 */		
		mean_xi_across_time = mean_xi_across_time/total_time_instance;
		rmse = rmse/total_time_instance;
		final_rmse = Math.sqrt(rmse);



		System.out.println("\n\ntotal time instance "+total_time_instance);
		System.out.println("avg x_i "+mean_xi_across_time);
		System.out.println("RMSE = "+final_rmse);

		

		
		return final_rmse;
	}


	int closestTimePoint(ArrayList <Double> times, double time, int low, int high){
		//Collections.sort(times);
		int found_index=0;
		double closest = 1000.00;
		for (int index=low;index<high;index++){
			if(index<times.size()){
				if(time-times.get(index)>0 && (time-times.get(index))<closest){
					closest = (time-times.get(index));
					found_index = index;
				}

			}
		}

		return found_index;

	}

	public void generateFalsePositive(String instruction){
		double prob = randomizer.nextDouble();
		if (prob<=this.haptest.getHap().getFp()) {
			if (instruction.equals("increase")) {
				this.haptest.increaseParkingAvailability();
				System.err.println("i-type false positive report observed");
			}
			else if (instruction.equals("decrease")) {
				this.haptest.decreaseParkingAvailability();
				System.err.println("d- type false positive report observed");
			}
		}
	}

	/*public void processUtilities(Timestamp t) {
		///utility = new Utilities();
		String hourMin =(t.toString().split(" ")[1]).split("\\.")[0]; 
		this.utility.getTime_map().add(hourMin);
		this.utility.getHAP_list().add(this.haptest.getHap().getAi());
		this.utility.getTrue_avl_list().add(this.haptest.getHap().getXi());
		this.utility.getHistorical_mean_list().add(this.haptest.getqt());
		this.utility.getHistorical_variance_list().add(this.haptest.getQt());
	
		
	}*/

}
