package com.parking.main;



import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.sql.ResultSet;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

import com.parking.HAPEstimation.BooleanClassAndAutoCorrect;
import com.parking.HAPEstimation.HAPConstruction;
import com.parking.HAPEstimation.PAEResultsObject;
import com.parking.HAPEstimation.Utilities;
/**
 * @author leon stenneth, lstennethATgmail.com
 *
 */
//This class evaluates the PAE with RMSE, boolean classification, and auto-correctness
public class PAEExperiments {
	private static HashMap <String, String> hapDataMap;
	
	private HAPConstruction haptest;
	private Random randomizer,random;
	private Utilities utility;
	private static int global_map_index = 0;
	private Time start_of_permitted_parking_period=new Time(14, 15, 0); // start of;
	private Time end_of_permitted_parking_period =new Time(13, 15, 0); // end of permitted
	private static int permitted_period_count=0;
	private ArrayList <Integer> permitted_index_list;
	PrintWriter out,outc,outd;// = new PrintWriter(new FileWriter("C:\\Program Files\\apache-tomcat-6.0.33\\lib\\27\\HAP_RMSE_RESULTS_"+new Date()+".txt",true),true);
	private com.parking.PAEAlgorithms.HistoricalStatistics HS;
	private com.parking.PAEAlgorithms.ScaledPhonePark SPP;
	private com.parking.PAEAlgorithms.WeightedAverage WA;
	private com.parking.PAEAlgorithms.KalmanFilter KMF;

	private double spp=0.0;
	private double wa0=0.0,wa1=0.0,wa2=0.0,wa3=0.0,wa4=0.0,wa5=0.0,wa6=0.0,wa7=0.0,wa8=0.0,wa9=0.0,wa10=0.0;
	private ArrayList <Double> wa_with_fitted_weights;
	private double kmf=0.0;
	private int wa10Timing;
	
	private static double penetrationRatio;
	private static int block_id = 612032; 
	private static int num_of_experiments = 1;
	private static int num_operational_sensors = 12;

	public PAEExperiments() {
		try {
			random = new Random();
			randomizer = new Random();
			haptest = new HAPConstruction();
			utility = new Utilities();
			permitted_index_list = new ArrayList <Integer>();
			wa_with_fitted_weights = new ArrayList <Double>();

			permitted_index_list.add(0);//bootstrap
			out = new PrintWriter(new FileWriter("PAERMSE.txt",true),true);
			outc = new PrintWriter(new FileWriter("OUTC.txt",true),true);
			outd = new PrintWriter(new FileWriter("OUTD.txt",true),true);
			
			HS = new com.parking.PAEAlgorithms.HistoricalStatistics() ;
			SPP = new com.parking.PAEAlgorithms.ScaledPhonePark() ;
			KMF = new com.parking.PAEAlgorithms.KalmanFilter();
			WA= new com.parking.PAEAlgorithms.WeightedAverage(0.5);

		}

		catch(Exception e){
			e.printStackTrace();
		}
	}

	public static void main(String args[]) {
		PAEExperiments e = new PAEExperiments();
		
		
		double avg_rmse = 0.0,local_rmse=0.0, sum_rmse=0.0,avgKmfBool=0.0,avgKmfAuto=0.0,avgSppBool=0.0,avgSppAuto=0.0,avgHistBool=0.0,avgHistAuto=0.0,avgHapBool=0.0,avgHapAuto=0.0,avgWa0Bool=0.0,avgWa1Bool=0.0,avgWa2Bool=0.0,avgWa3Bool=0.0,avgWa4Bool=0.0,avgWa5Bool=0.0,avgWa6Bool=0.0,avgWa7Bool=0.0,avgWa8Bool=0.0,avgWa9Bool=0.0,avgWa10Bool=0.0;
		double avgWa10Auto=0.0,avgWa0Auto=0.0,avgWa1Auto=0.0,avgWa2Auto=0.0,avgWa3Auto=0.0,avgWa4Auto=0.0,avgWa5Auto=0.0,avgWa6Auto=0.0,avgWa7Auto=0.0,avgWa8Auto=0.0,avgWa9Auto=0.0;

		double sum_hap_result=0.0,sum_kmf_result=0.0,sum_spp_result=0.0,sum_qi_result=0.0,sum_wa0_result=0.0,sum_wa1_result=0.0,sum_wa2_result=0.0,sum_wa3_result=0.0,sum_wa4_result=0.0,sum_wa5_result=0.0,sum_wa6_result=0.0,sum_wa7_result=0.0,sum_wa8_result=0.0,sum_wa9_result=0.0,sum_wa10_result=0.0;
		double avg_hap_rmse=0.0,avg_kmf_rmse=0.0,avg_spp_rmse=0.0,avg_qi_rmse=0.0,avg_wa0_rmse=0.0,avg_wa1_rmse=0.0,avg_wa2_rmse=0.0,avg_wa3_rmse=0.0,avg_wa4_rmse=0.0,avg_wa5_rmse=0.0,avg_wa6_rmse=0.0,avg_wa7_rmse=0.0,avg_wa8_rmse=0.0,avg_wa9_rmse=0.0,avg_wa10_rmse=0.0;

		double sumWa10BoolResult = 0.0,sumKmfBoolResult = 0.0, sumSppBoolResult = 0.0, sumHapBoolResult = 0.0, sumHistBoolResult = 0.0, sumWa0BoolResult = 0.0, sumWa1BoolResult = 0.0, sumWa2BoolResult = 0.0, sumWa3BoolResult = 0.0, sumWa4BoolResult = 0.0, sumWa5BoolResult = 0.0, sumWa6BoolResult = 0.0, sumWa7BoolResult = 0.0, sumWa8BoolResult = 0.0, sumWa9BoolResult = 0.0; 
		double sumWa10AutoResult = 0.0,sumKmfAutoResult = 0.0, sumSppAutoResult = 0.0, sumHapAutoResult = 0.0, sumHistAutoResult = 0.0, sumWa0AutoResult = 0.0, sumWa1AutoResult = 0.0, sumWa2AutoResult = 0.0, sumWa3AutoResult = 0.0, sumWa4AutoResult = 0.0, sumWa5AutoResult = 0.0, sumWa6AutoResult = 0.0, sumWa7AutoResult = 0.0, sumWa8AutoResult = 0.0, sumWa9AutoResult = 0.0; 

		for(double penetration_ratio=0.01;penetration_ratio<=0.01;penetration_ratio+=0.49){
			penetrationRatio = penetration_ratio;

			
			e.out.println("penetration ratio: "+penetration_ratio);
			e.outc.println("penetration ratio: "+penetration_ratio);
			e.outd.println("penetration ratio: "+penetration_ratio);

			for(double false_negtive_prob=0.25;false_negtive_prob<=0.25;false_negtive_prob+=0.15) {
				//for double false_negtive_prob=0.0;false_negtive_prob<=0.26;false_negtive_prob+=0.05) {
				double 	false_postive_prob = 0;
				
				e.out.println("fp = "+false_postive_prob+",");
				e.outc.println("fp = "+false_postive_prob+",");	
				e.outd.println("fp = "+false_postive_prob+",");	
				
				avg_rmse = 0.0;local_rmse=0.0; sum_rmse=0.0;
				
				e.out.println("fn = "+false_negtive_prob+",");
				e.outc.println("fn = "+false_negtive_prob+",");
				e.outd.println("fn = "+false_negtive_prob+",");
				
				String hapFileQueryString = "fn:"+false_negtive_prob+"fp:"+false_postive_prob+"b:"+penetration_ratio;
				hapDataMap = e.getHapDataFromFile(hapFileQueryString);
				
				for(int index=0;index<num_of_experiments;index++){
					e = new PAEExperiments();
					e.haptest.getHap().setFn(false_negtive_prob);
					e.haptest.getHap().setFp(false_postive_prob);	
					e.haptest.getHap().setStreet_block_id(block_id);
					e.haptest.getHap().setN(num_operational_sensors);
					e.haptest.getHap().setStartTimeFrameForValidation("2012-04-10"/**2012-03-07*/);// when
					e.haptest.getHap().setEndTimeFrameForValidation("2012-08-11");
					e.haptest.getHap().setB(penetration_ratio);
					
					PAEResultsObject local_result = e.PAEPerSecond();

					//-------process the results------------
					sum_hap_result = sum_hap_result+local_result.getHap_rmse();
					sum_kmf_result = sum_kmf_result+local_result.getKmf_rmse();
					sum_spp_result = sum_spp_result +local_result.getSpp_rmse();
					sum_qi_result = sum_qi_result +local_result.getQi_rmse();
					sum_wa0_result = sum_wa0_result +local_result.getWa0_rmse();
					sum_wa1_result = sum_wa1_result +local_result.getWa1_rmse();
					sum_wa2_result = sum_wa2_result +local_result.getWa2_rmse();
					sum_wa3_result = sum_wa3_result +local_result.getWa3_rmse();
					sum_wa4_result = sum_wa4_result +local_result.getWa4_rmse();
					sum_wa5_result = sum_wa5_result +local_result.getWa5_rmse();
					sum_wa6_result = sum_wa6_result +local_result.getWa6_rmse();
					sum_wa7_result = sum_wa7_result +local_result.getWa7_rmse();
					sum_wa8_result = sum_wa8_result +local_result.getWa8_rmse();
					sum_wa9_result = sum_wa9_result +local_result.getWa9_rmse();
					sum_wa10_result = sum_wa10_result +local_result.getWa10_rmse();
					
					e.outc.println("KMF" +index+": "+local_result.getKmf_rmse());
					e.outd.println("SPP" +index+": "+local_result.getSpp_rmse());
					
					
					//----------end of RMSE process--------------

					BooleanClassAndAutoCorrect classAutoResults = e.getBoolClassifAndAutoCorrect();

					sumKmfBoolResult = sumKmfBoolResult + classAutoResults.getKalmanBoolClassification();
					sumKmfAutoResult = sumKmfAutoResult + classAutoResults.getKalmanAutoCorrectness();

					sumSppBoolResult = sumSppBoolResult + classAutoResults.getSppBoolClassification();
					sumSppAutoResult = sumSppAutoResult + classAutoResults.getSppAutoCorrectness();

					sumHapBoolResult = sumHapBoolResult + classAutoResults.getHapBoolClassification();
					sumHapAutoResult = sumHapAutoResult + classAutoResults.getHapAutoCorrectness();

					sumHistBoolResult = sumHistBoolResult + classAutoResults.getHistBoolClassification();
					sumHistAutoResult = sumHistAutoResult + classAutoResults.getHistAutoCorrectness();

					sumWa0BoolResult = sumWa0BoolResult + classAutoResults.getWa0BoolClassification();
					sumWa0AutoResult = sumWa0AutoResult + classAutoResults.getWa0AutoCorrectness();

					sumWa1BoolResult = sumWa1BoolResult + classAutoResults.getWa1BoolClassification();
					sumWa1AutoResult = sumWa1AutoResult + classAutoResults.getWa1AutoCorrectness();

					sumWa2BoolResult = sumWa2BoolResult + classAutoResults.getWa2BoolClassification();
					sumWa2AutoResult = sumWa2AutoResult + classAutoResults.getWa2AutoCorrectness();

					sumWa3BoolResult = sumWa3BoolResult + classAutoResults.getWa3BoolClassification();
					sumWa3AutoResult = sumWa3AutoResult + classAutoResults.getWa3AutoCorrectness();

					sumWa4BoolResult = sumWa4BoolResult + classAutoResults.getWa4BoolClassification();
					sumWa4AutoResult = sumWa4AutoResult + classAutoResults.getWa4AutoCorrectness();

					sumWa5BoolResult = sumWa5BoolResult + classAutoResults.getWa5BoolClassification();
					sumWa5AutoResult = sumWa5AutoResult + classAutoResults.getWa5AutoCorrectness();

					sumWa6BoolResult = sumWa6BoolResult + classAutoResults.getWa6BoolClassification();
					sumWa6AutoResult = sumWa6AutoResult + classAutoResults.getWa6AutoCorrectness();

					sumWa7BoolResult = sumWa7BoolResult + classAutoResults.getWa7BoolClassification();
					sumWa7AutoResult = sumWa7AutoResult + classAutoResults.getWa7AutoCorrectness();

					sumWa8BoolResult = sumWa8BoolResult + classAutoResults.getWa8BoolClassification();
					sumWa8AutoResult = sumWa8AutoResult + classAutoResults.getWa8AutoCorrectness();

					sumWa9BoolResult = sumWa9BoolResult + classAutoResults.getWa9BoolClassification();
					sumWa9AutoResult = sumWa9AutoResult + classAutoResults.getWa9AutoCorrectness();			

					sumWa10BoolResult = sumWa10BoolResult + classAutoResults.getWa10BoolClassification();
					sumWa10AutoResult = sumWa10AutoResult + classAutoResults.getWa10AutoCorrectness();			


				} //end for

				//---------computing the avg-----------------
				avg_hap_rmse = sum_hap_result/num_of_experiments;
				avg_kmf_rmse = sum_kmf_result/num_of_experiments;
				avg_spp_rmse = sum_spp_result/num_of_experiments;
				avg_qi_rmse = sum_qi_result/num_of_experiments;
				avg_wa0_rmse = sum_wa0_result/num_of_experiments;
				avg_wa1_rmse = sum_wa1_result/num_of_experiments;
				avg_wa2_rmse = sum_wa2_result/num_of_experiments;
				avg_wa3_rmse = sum_wa3_result/num_of_experiments;
				avg_wa4_rmse = sum_wa4_result/num_of_experiments;
				avg_wa5_rmse = sum_wa5_result/num_of_experiments;
				avg_wa6_rmse = sum_wa6_result/num_of_experiments;
				avg_wa7_rmse = sum_wa7_result/num_of_experiments;
				avg_wa8_rmse = sum_wa8_result/num_of_experiments;
				avg_wa9_rmse = sum_wa9_result/num_of_experiments;
				avg_wa10_rmse = sum_wa10_result/num_of_experiments;

				//e.out.println("HAP " +avg_hap_rmse);
				e.out.println("KMF " +avg_kmf_rmse);
				e.out.println("SPP " +avg_spp_rmse);
				e.out.println("HAP " +avg_qi_rmse);
				e.out.println("Wa0 " +avg_wa0_rmse);
				e.out.println("Wa1 " +avg_wa1_rmse);
				e.out.println("Wa2 " +avg_wa2_rmse);
				e.out.println("Wa3 " +avg_wa3_rmse);
				e.out.println("Wa4 " +avg_wa4_rmse);
				e.out.println("Wa5 " +avg_wa5_rmse);
				e.out.println("Wa6 " +avg_wa6_rmse);
				e.out.println("Wa7 " +avg_wa7_rmse);
				e.out.println("Wa8 " +avg_wa8_rmse);
				e.out.println("Wa9 " +avg_wa9_rmse);
				e.out.println("Wa10 " +avg_wa10_rmse);

				avgKmfBool = sumKmfBoolResult/num_of_experiments;
				avgKmfAuto = sumKmfAutoResult/num_of_experiments;

				avgSppBool = sumSppBoolResult/num_of_experiments;
				avgSppAuto = sumSppAutoResult/num_of_experiments;

				avgHistBool = sumHistBoolResult/num_of_experiments;
				avgHistAuto = sumHistAutoResult/num_of_experiments;

				avgHapBool = sumHapBoolResult/num_of_experiments;
				avgHapAuto = sumHapAutoResult/num_of_experiments;

				avgWa0Bool = sumWa0BoolResult/num_of_experiments;
				avgWa0Auto = sumWa0AutoResult/num_of_experiments;

				avgWa1Bool = sumWa1BoolResult/num_of_experiments;
				avgWa1Auto = sumWa1AutoResult/num_of_experiments;

				avgWa2Bool = sumWa2BoolResult/num_of_experiments;
				avgWa2Auto = sumWa2AutoResult/num_of_experiments;

				avgWa3Bool = sumWa3BoolResult/num_of_experiments;
				avgWa3Auto = sumWa3AutoResult/num_of_experiments;

				avgWa4Bool = sumWa4BoolResult/num_of_experiments;
				avgWa4Auto = sumWa4AutoResult/num_of_experiments;

				avgWa5Bool = sumWa5BoolResult/num_of_experiments;
				avgWa5Auto = sumWa5AutoResult/num_of_experiments;

				avgWa6Bool = sumWa6BoolResult/num_of_experiments;
				avgWa6Auto = sumWa6AutoResult/num_of_experiments;

				avgWa7Bool = sumWa7BoolResult/num_of_experiments;
				avgWa7Auto = sumWa7AutoResult/num_of_experiments;

				avgWa8Bool = sumWa8BoolResult/num_of_experiments;
				avgWa8Auto = sumWa8AutoResult/num_of_experiments;

				avgWa9Bool = sumWa9BoolResult/num_of_experiments;
				avgWa9Auto = sumWa9AutoResult/num_of_experiments;

				avgWa10Bool = sumWa10BoolResult/num_of_experiments;
				avgWa10Auto = sumWa10AutoResult/num_of_experiments;

				e.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$");


				//e.out.println("HAP BoolClassification " +avgHapBool);
				e.out.println("KMF BoolClassification " +avgKmfBool);
				e.out.println("SPP BoolClassification " +avgSppBool);
				e.out.println("HAP BoolClassification " +avgHistBool);
				e.out.println("Wa0 BoolClassification " +avgWa0Bool);
				e.out.println("Wa1 BoolClassification " +avgWa1Bool);
				e.out.println("Wa2 BoolClassification " +avgWa2Bool);
				e.out.println("Wa3 BoolClassification " +avgWa3Bool);
				e.out.println("Wa4 BoolClassification " +avgWa4Bool);
				e.out.println("Wa5 BoolClassification " +avgWa5Bool);
				e.out.println("Wa6 BoolClassification " +avgWa6Bool);
				e.out.println("Wa7 BoolClassification " +avgWa7Bool);
				e.out.println("Wa8 BoolClassification " +avgWa8Bool);
				e.out.println("Wa9 BoolClassification " +avgWa9Bool);
				e.out.println("Wa10 BoolClassification " +avgWa10Bool);


				e.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$");

				//e.out.println("HAP AutoCorrectness " +avgHapAuto);
				e.out.println("KMF AutoCorrectness " +avgKmfAuto);
				e.out.println("SPP AutoCorrectness " +avgSppAuto);
				e.out.println("HAP AutoCorrectness " +avgHistAuto);
				e.out.println("Wa0 AutoCorrectness " +avgWa0Auto);
				e.out.println("Wa1 AutoCorrectness " +avgWa1Auto);
				e.out.println("Wa2 AutoCorrectness " +avgWa2Auto);
				e.out.println("Wa3 AutoCorrectness " +avgWa3Auto);
				e.out.println("Wa4 AutoCorrectness " +avgWa4Auto);
				e.out.println("Wa5 AutoCorrectness " +avgWa5Auto);
				e.out.println("Wa6 AutoCorrectness " +avgWa6Auto);
				e.out.println("Wa7 AutoCorrectness " +avgWa7Auto);
				e.out.println("Wa8 AutoCorrectness " +avgWa8Auto);
				e.out.println("Wa9 AutoCorrectness " +avgWa9Auto);
				e.out.println("Wa10 AutoCorrectness " +avgWa10Auto);

				//---------end-------------------------------

				sum_kmf_result=0.0;sum_spp_result=0.0;sum_qi_result=0.0;sum_wa0_result=0.0;sum_wa1_result=0.0;sum_wa2_result=0.0;sum_wa3_result=0.0;sum_wa4_result=0.0;sum_wa5_result=0.0;sum_wa6_result=0.0;sum_wa7_result=0.0;sum_wa8_result=0.0;sum_wa9_result=0.0;sum_wa10_result=0.0;sumHistBoolResult=0.0;sumHistAutoResult=0.0;sumKmfBoolResult=0.0;sumKmfAutoResult=0.0;sumHapBoolResult=0.0;sumHapAutoResult=0.0;sumSppBoolResult=0.0;sumSppAutoResult=0.0;sumWa0BoolResult=0.0;sumWa0AutoResult=0.0;sumWa1BoolResult=0.0;sumWa1AutoResult=0.0;sumWa2BoolResult=0.0;sumWa2AutoResult=0.0;sumWa3BoolResult=0.0;sumWa3AutoResult=0.0;sumWa10BoolResult=0.0;sumWa4AutoResult=0.0;sumWa4BoolResult=0.0;sumWa5AutoResult=0.0;sumWa5BoolResult=0.0;sumWa6AutoResult=0.0;sumWa6BoolResult=0.0;sumWa7AutoResult=0.0;sumWa7BoolResult=0.0;sumWa8AutoResult=0.0;sumWa8BoolResult=0.0;sumWa9AutoResult=0.0;sumWa9BoolResult=0.0;sumWa10AutoResult=0.0;

			}
		}

	}

	//}

	@SuppressWarnings("deprecation")
	public Boolean startOfPermittedPeriod(Timestamp t){
		Boolean start_of_permitted_period=false;
		if(t.getHours()==this.end_of_permitted_parking_period.getHours()&&t.getMinutes()>this.end_of_permitted_parking_period.getMinutes()){   // 7:45
			start_of_permitted_period=true;
			permitted_period_count++;
			//System.out.println("permitted period");
			return start_of_permitted_period;
		}

		else if(t.getHours()==this.start_of_permitted_parking_period.getHours()&&t.getMinutes()<this.start_of_permitted_parking_period.getMinutes()){ //8:15
			start_of_permitted_period=true;
			permitted_period_count++;
			//System.out.println("permitted period");
			return start_of_permitted_period;
		}

		return start_of_permitted_period;
	}

	public int getAvailability(Calendar cal, HashMap<Timestamp, Integer> avlMap) {
		// TODO Auto-generated method stub
		return avlMap.get(this.closest(new Timestamp(cal.getTimeInMillis()),new ArrayList<Timestamp>(avlMap.keySet())));
	}

	public Timestamp closest(Timestamp cal, List<Timestamp> in) {
		Collections.sort(in);
		long min = Long.MAX_VALUE;
		Timestamp closest = in.get(0);

		for (Timestamp v : in) {
			final long diff = cal.getTime()-v.getTime() ;

			if (diff < min && diff>0) {
				//System.out.println("feeeeeeeeee");
				min = diff;
				closest = v;
			}

			if(v.getTime()>cal.getTime()){ //since it is sorted
				break;
			}
		}

		return closest;
	}


	public HashMap <String, String> getHapDataFromFile (String dataLocator){
		HashMap <String, String>  map =  new HashMap <String, String> ();

		try {
			BufferedReader readHapFile = new BufferedReader(new FileReader ("HAPMEANANDVAR"+block_id+".txt"));//"HAPMEANANDVAR"+block_id+".txt",true),true
			String line = readHapFile.readLine();
			while (line!=null){
				if(line.equals(dataLocator)) {
					System.out.println(line);
					line = readHapFile.readLine();
					System.out.println(line);
					while (line!=null&&!line.contains("fp")){
						String lineData [] = line.split(",");
						map.put(lineData[0], lineData[1]+","+lineData[2]);
						line = readHapFile.readLine();
					}

					break;
				}
				line = readHapFile.readLine();
			}
		}
		catch (Exception e){
			e.printStackTrace();
			//System.exit(0);
		}

		return map;
	}


	@SuppressWarnings("deprecation")
	public PAEResultsObject PAEPerSecond() {
		Boolean permittedPeriod = false;
		permitted_period_count = 0;
		ResultSet rs = this.haptest.getHap().getValidationPieceOfDataFromDB();
		boolean coldStart = true;
		HashMap <java.sql.Timestamp, Integer> avlMap = new HashMap<java.sql.Timestamp, Integer>();

		// per minute validation

		// per minute validation
		try {
			rs.next();
			Calendar cal= Calendar.getInstance();
			cal.setTime(rs.getTimestamp(4));//rs first date
			
			while(rs.next()){
				avlMap.put(rs.getTimestamp(4), rs.getInt(2));
			}

			rs.last();//move curser to last row
			Calendar endCal= Calendar.getInstance();
			endCal.setTime(rs.getTimestamp(4));

			while (cal.getTime().before(endCal.getTime())) {

				this.haptest.getHap().setHistory_start_hour(cal.getTime().getHours());
				this.haptest.getHap().setHistory_start_minute(cal.getTime().getMinutes());
				this.haptest.getHap().setHistory_start_second(cal.getTime().getSeconds());

				// increment by 1 second..taking care of border line cases
				if (cal.getTime().getMinutes() < 59) { // if not the 59th second
					this.haptest.getHap().setHistory_end_hour(cal.getTime().getHours());
					this.haptest.getHap().setHistory_end_minute(
							cal.getTime().getMinutes()+1);
					//this.haptest.getHap().setHistory_end_second(cal.getTime().getSeconds()+1);
				} 
				else {
					this.haptest.getHap().setHistory_end_hour(cal.getTime().getHours()+1);
					//this.haptest.getHap().setHistory_end_minute(cal.getTime().getMinutes()+1
					//	);
					this.haptest.getHap().setHistory_end_minute(0 + (cal.getTime().getMinutes() - 59));

				}




				// setting the true parking availability and observed
				// availability, at cold start this should be N
				int current_xi = getAvailability(cal, avlMap);

				//System.out.println("$$$$$$$$$$$$$$$$$$$"+cal.getTime().toString()+"$$$$$$$$$"+current_xi);
				double a = 0;
				if (coldStart) {
					this.haptest.getHap().setXi(current_xi);
					this.haptest.getHap().setAi(current_xi);
					coldStart = false;
					//continue;
				}

				permittedPeriod=false;

				if(this.startOfPermittedPeriod(new Timestamp(cal.getTimeInMillis())) /**&&rs.getInt(2)==10*/){
					this.haptest.getHap().setXi(current_xi);
					this.haptest.getHap().setAi(current_xi);
					permittedPeriod = true;
					if(cal.getTime().getMinutes()==59){ //tryna to make it once per day
						permitted_index_list.add(0);
						//System.out.println("restricted period "+cal.getTime().toString());
					}


					//--------------------------KM Filter reset------------
					com.parking.PAEAlgorithms.KalmanFilter.setrt(0);
					com.parking.PAEAlgorithms.KalmanFilter.setRt(0);
					com.parking.PAEAlgorithms.KalmanFilter.Q_i_hat_list=new ArrayList<Double>();
					com.parking.PAEAlgorithms.KalmanFilter.r_i_hat_list=new ArrayList<Double>();
					//-------------------------------------------------
				}

				else if (this.haptest.getHap().getXi() > current_xi) { // if people parked
					double iteration_count = (this.haptest.getHap().getXi() - current_xi);
					int fpCount=0;
					for (int k = 0; k < iteration_count; k++) {
						a = randomizer.nextDouble();// generate a random
						// number between 0 and 1
						double probability = this.haptest.getHap().getB()
								* (1-this.haptest.getHap().getFn())/**this.haptest.getHap().getPsd_accuracy()*/;
						if (a <= probability) {
							this.haptest.decreaseParkingAvailability();
							fpCount++;
							//this.generateFalsePositive("decrease");//generate false positives
						}
					}

					//generate count number of false positive reports count = negBin(fpCount, fp)
					int negBinomial = Utilities.NBRandom(fpCount, this.haptest.getHap().getFp(), random);
					for(int count=0;count< negBinomial ; count++){
						this.generateFalsePositive("decrease");//generate false positives
					}
				} 

				else if (this.haptest.getHap().getXi() < current_xi) { // if people deparked
					double iteration_count= current_xi - this.haptest.getHap()
							.getXi();
					int fpCount=0;
					for (int j = 0; j <iteration_count; j++) {
						a = randomizer.nextDouble();// generate a random
						// number between 0 and 1
						double probability = this.haptest.getHap().getB()
								* (1-this.haptest.getHap().getFn())/**this.haptest.getHap().getPsd_accuracy()*/;
						if (a <= (probability)) {
							this.haptest.increaseParkingAvailability();
							fpCount++;
							//this.generateFalsePositive("increase");//generate false positives
						}
					}

					//generate count number of false positive reports count = negBin(fpCount, fp) fpcount is based on coin toss
					int negBinomial = Utilities.NBRandom(fpCount, this.haptest.getHap().getFp(), random);
					for(int count=0;count< negBinomial ; count++){
						this.generateFalsePositive("increase");//generate false positives
					}

				}

				this.haptest.getHap().setXi(current_xi);

				this.spp= this.SPP.computeSPPAvailability(this.haptest.getHap().getAi(), num_operational_sensors); //scaling observations
				//System.out.println("SPP "+spp);

				//////////////calling the other PAE algorithms//////////////
				//System.out.println(" PAE: penetration ratio"+this.haptest.getHap().getB());
				//this.HS.setHistoricalStatistics(); //computing and setting qt and Qt from history data not from validation data
				//System.out.println("TRUE "+this.haptest.getHap().getXi());
				//System.out.println(" PAE: penetration ratio"+this.haptest.getHap().getB());				




				//HAP mean processing
				if(hapDataMap!=null && hapDataMap.containsKey(cal.getTime().getHours()+":"+cal.getTime().getMinutes())){
					//System.out.println(cal.getTime().getHours()+":"+cal.getTime().getMinutes());
					String meanWithVar [] = hapDataMap.get(cal.getTime().getHours()+":"+cal.getTime().getMinutes()).split(",");
					this.haptest.setqt(Double.parseDouble(meanWithVar[0]));
					this.haptest.setQt(Double.parseDouble(meanWithVar[1]));
					//---------------end hap mean processing
				}
				else {
					System.out.println("....");
					if(hapDataMap==null) {
						System.err.println("HAP DATA MAP EMPTY");
						System.exit(0);
					}
					

				}

				/*System.out.println("HAP qt "+this.haptest.getqt());

				System.out.println("PAE ai "+this.haptest.getHap().getAi());

				System.out.println("HAP Qt "+this.haptest.getQt());*/

				this.wa0 = this.WA.getWeightedAverageAvl(0);  //both history and observation using fitted weights
				
				this.wa1 = this.WA.getWeightedAverageAvl(0.1);  //both history and observation using fitted weights
				//System.out.println("WA1 "+this.wa1);

				this.wa2 = this.WA.getWeightedAverageAvl(0.2);  //both history and observation using fitted weights
				//System.out.println("WA2 "+this.wa2);

				this.wa3 = this.WA.getWeightedAverageAvl(0.3);  //both history and observation using fitted weights
				//System.out.println("WA3 "+this.wa3);

				this.wa4 = this.WA.getWeightedAverageAvl(0.4);  //both history and observation using fitted weights
				//System.out.println("WA4 "+this.wa4);

				this.wa5 = this.WA.getWeightedAverageAvl(0.5);  //both history and observation using fitted weights
				//System.out.println("WA5 "+this.wa5);

				this.wa6 = this.WA.getWeightedAverageAvl(0.6);  //both history and observation using fitted weights
				//System.out.println("WA6 "+this.wa6);

				this.wa7 = this.WA.getWeightedAverageAvl(0.7);  //both history and observation using fitted weights
				//System.out.println("WA7 "+this.wa7);

				this.wa8 = this.WA.getWeightedAverageAvl(0.8);  //both history and observation using fitted weights
				//System.out.println("WA8 "+this.wa8);

				this.wa9 = this.WA.getWeightedAverageAvl(0.9);  //both history and observation using fitted weights
				//System.out.println("WA9 "+this.wa9);

				this.wa10 = this.WA.getWeightedAverageAvl(1);  //both history and observation using fitted weights
				//System.out.println("WA10 "+this.wa10);


				wa_with_fitted_weights = this.WA.getWeightedAverages();// List of double with all possible weights with 0.1 increments
				//System.out.println("WA LIST "+wa_with_fitted_weights.toString());

				//this.kmf = this.KMF.BoVersionOfKalmanFilter();
				this.kmf= this.KMF.BoVersionOfKalmanFilter2YangComment();
				//System.out.println("Bo KMF "+this.kmf);

				//System.out.println("-------------------------------------------");
				/////////////////now compute the RMSE of these and the true, which is x_i
				///////////////end/////////////////

				this.processUtilities(new Timestamp(cal.getTimeInMillis()));

				/*System.out.println("true:" + this.haptest.getHap().getXi());
				System.out.println("HAP:" + this.haptest.getHap().getAi());
				System.out.println("historical mean: " + this.haptest.getqt()
						+ " var: " + this.haptest.getQt());
				System.out.println("----------------------");*/

				cal.add(Calendar.MINUTE, 1);
				System.out.println(cal.getTime().toString());
			} // end while

			rs.close();
		} 
		catch (Exception e) {
			e.printStackTrace();
			//System.exit(0);
		}
		this.utility.convertTimeMapofStringToDoubles();

		PAEResultsObject rmse_object  = new PAEResultsObject() ;
		try {
			rmse_object = this.runSimulationPerSecond();
		}
		catch(Exception e){
			e.printStackTrace();
		}
		System.out.println("total permitted periods   "+permitted_period_count);

		return rmse_object;
	}


	


	public void processUtilities(Timestamp t) {
		String hourMin =(t.toString().split(" ")[1]).split("\\.")[0]; 
		this.utility.getTime_map().add(hourMin);



		this.utility.getHAP_list().add(this.haptest.getHap().getAi());
		this.utility.getTrue_avl_list().add(this.haptest.getHap().getXi());
		this.utility.getHistorical_mean_list().add(this.haptest.getqt());
		this.utility.getHistorical_variance_list().add(this.haptest.getQt());
		this.utility.getSpp_list().add(spp);
		this.utility.getWa0_list().add(wa0);
		this.utility.getWa1_list().add(wa1);
		this.utility.getWa2_list().add(wa2);
		this.utility.getWa3_list().add(wa3);
		this.utility.getWa4_list().add(wa4);
		this.utility.getWa5_list().add(wa5);
		this.utility.getWa6_list().add(wa6);
		this.utility.getWa7_list().add(wa7);
		this.utility.getWa8_list().add(wa8);
		this.utility.getWa9_list().add(wa9);
		this.utility.getWa10_list().add(wa10);
		this.utility.getKmf_list().add(kmf);

	}

	public BooleanClassAndAutoCorrect getBoolClassifAndAutoCorrect(){
		Boolean debug=false;
		BooleanClassAndAutoCorrect obj = new BooleanClassAndAutoCorrect();

		double init = 0.0;
		double kalmanAvlCount = 0,sppAvlCount=0,histAvlCount=0, hapAvlCount=0,wa0AvlCount=0,wa1AvlCount=0,wa2AvlCount=0,wa3AvlCount=0,wa4AvlCount=0,wa5AvlCount=0,wa6AvlCount=0,wa7AvlCount=0,wa8AvlCount=0,wa9AvlCount=0,wa10AvlCount=0;

		Boolean incorrectKalman=false,incorrectSpp=false,incorrectHap=false,incorrectHist=false,incorrectWa0=false,incorrectWa1=false,incorrectWa2=false,incorrectWa3=false,incorrectWa4=false,incorrectWa5=false,incorrectWa6=false,incorrectWa7=false,incorrectWa8=false,incorrectWa9=false,incorrectWa10=false;
		int kalmanTiming=0, kalmanTimer=0,sppTiming=0,sppTimer=0,hapTiming=0,hapTimer=0,histTiming=0,histTimer=0,wa0Timing=0,wa0Timer=0,wa1Timing=0,wa1Timer=0,wa2Timing=0,wa2Timer=0,wa3Timing=0,wa3Timer=0,wa4Timing=0,wa4Timer=0,wa5Timing=0,wa5Timer=0,wa6Timing=0,wa6Timer=0,wa7Timing=0,wa7Timer=0,wa8Timing=0,wa8Timer=0,wa9Timing=0,wa9Timer=0,wa10Timer=0,wa10Timing=0;
		ArrayList <Integer> kalmanTimerList =  new ArrayList <Integer>(), sppTimerList=  new ArrayList <Integer>(),hapTimerList=  new ArrayList <Integer>(),histTimerList=  new ArrayList <Integer>(),wa0TimerList=  new ArrayList <Integer>(),wa1TimerList=  new ArrayList <Integer>(),wa2TimerList=  new ArrayList <Integer>(),wa3TimerList=  new ArrayList <Integer>(),wa4TimerList=  new ArrayList <Integer>(),wa5TimerList=  new ArrayList <Integer>(),wa6TimerList=  new ArrayList <Integer>(),wa7TimerList=  new ArrayList <Integer>(),wa8TimerList=  new ArrayList <Integer>(),wa9TimerList=  new ArrayList <Integer>(),wa10TimerList=  new ArrayList <Integer>();

		double trueAvl = 0, kalmanAvl=0.0,spp=0.0, hist=0.0, hap=0.0,wa0=0.0,wa1=0.0,wa2=0.0,wa3=0.0,wa4=0.0,wa5=0.0,wa6=0.0,wa7=0.0,wa8=0.0,wa9=0.0,wa10=0.0;
		if(debug)
			System.err.println("size: "+utility.getKmf_list().size());
		for (int index=0; index<this.utility.getKmf_list().size();index++){

			trueAvl = this.utility.getTrue_avl_list().get(index);
			if (debug)
				System.out.println("trueAvl "+trueAvl);
			kalmanAvl = this.utility.getKmf_list().get(index);
			if(debug)
				System.out.println("kalmanAvl "+kalmanAvl);

			spp = this.utility.getSpp_list().get(index);
			if(debug)
				System.out.println("sppAvl "+spp);
			
			hist = this.utility.getHistorical_mean_list().get(index);
			hap = this.utility.getHAP_list().get(index);
			if(debug)
				System.out.println("apAvl "+hist);
			wa0  = this.utility.getWa0_list().get(index);
			if(debug)
				System.out.println("Wa0Avl "+wa0);
			wa1  = this.utility.getWa1_list().get(index);
			wa2  = this.utility.getWa2_list().get(index);
			wa3  = this.utility.getWa3_list().get(index);
			wa4  = this.utility.getWa4_list().get(index);
			wa5  = this.utility.getWa5_list().get(index);
			wa6  = this.utility.getWa6_list().get(index);
			wa7  = this.utility.getWa7_list().get(index);
			wa8  = this.utility.getWa8_list().get(index);
			wa9  = this.utility.getWa9_list().get(index);
			
			if(debug)
				System.out.println("Wa9Avl "+wa9);
			wa10  = this.utility.getWa10_list().get(index);
			
			if(debug)
				System.out.println("Wa10Avl "+wa10);

			if(trueAvl>=0.5 && kalmanAvl>=0.5 || trueAvl<0.5 && kalmanAvl<0.5){ //correct
				kalmanAvlCount++;
				if(debug)
					System.out.println("kalmanAvlCount "+kalmanAvlCount);
				if(incorrectKalman==true){
					kalmanTiming = index-kalmanTimer;

					if(debug)
						System.out.println("kalmanTiming "+kalmanTiming);

					kalmanTimerList.add(kalmanTiming);
					incorrectKalman=false;
					//System.out.println("CORRECTED KALMAN $$$$$$$$$$$$$$" + index + "auto-corrected"+kalmanTiming+" true:avl"+trueAvl+":"+kalmanAvl);
				}
			}
			else if (trueAvl>=0.5 && kalmanAvl<0.5 || trueAvl<=0.5 && kalmanAvl > 0.5){ //incorrect

				//System.out.println("INCORRECT KALMAN $$$$$$$$$$$$$$" + index + "true:avl"+trueAvl+":"+kalmanAvl);
				if(incorrectKalman!=true){
					kalmanTimer = index;
				}
				incorrectKalman = true;
			}
			//--------------------------------


			if(trueAvl>=0.5 && spp>=0.5 || trueAvl<0.5 && spp<0.5){
				sppAvlCount++;
				if(debug)
					System.out.println("sppAvlCount "+sppAvlCount);
				if(incorrectSpp==true){
					sppTiming = index-sppTimer;
					sppTimerList.add(sppTiming);
					incorrectSpp=false;
				}
			}
			else if (trueAvl>=0.5 && spp<0.5 || trueAvl<=0.5 && spp > 0.5){ //incorrect

				if(incorrectSpp!=true){
					sppTimer = index;
				}
				incorrectSpp = true;
			}

			//---------------------------------------

			if(trueAvl>=0.5 && hist>=0.5 || trueAvl<0.5 && hist<0.5){
				histAvlCount++;
				if(incorrectHist==true){
					histTiming = index-histTimer;
					histTimerList.add(histTiming);
					incorrectHist=false;
				}
			}

			else if (trueAvl>=0.5 && hist<0.5 || trueAvl<=0.5 && hist > 0.5){ //incorrect	
				if(incorrectHist!=true){
					histTimer = index;
				}
				incorrectHist = true;

			}

			//--------------------------

			if(trueAvl>=0.5 && hap>=0.5 || trueAvl<0.5 && hap<0.5){
				hapAvlCount++;
				if(incorrectHap==true){
					hapTiming = index-hapTimer;
					hapTimerList.add(hapTiming);
					incorrectHap=false;
				}
			}

			else if (trueAvl>=0.5 && hap<0.5 || trueAvl<=0.5 && hap > 0.5){ //incorrect

				if(incorrectHap!=true){
					hapTimer = index;
				}
				incorrectHap = true;
			}

			//-----------------------------------------

			if(trueAvl>=0.5 && wa0>=0.5 || trueAvl<=0.5 && wa0<=0.5){
				wa0AvlCount++;
				if(incorrectWa0==true){
					wa0Timing = index-wa0Timer;
					wa0TimerList.add(wa0Timing);
					incorrectWa0=false;
				}
			}

			else if (trueAvl>=0.5 && wa0<0.5 || trueAvl<0.5 && wa0 >= 0.5){ //incorrect


				if(incorrectWa0!=true){
					wa0Timer = index;
				}
				incorrectWa0 = true;
			}

			//--------------------------------------------

			if(trueAvl>=0.5 && wa1>=0.5 || trueAvl<0.5 && wa1<0.5){
				wa1AvlCount++;

				if(incorrectWa1==true){
					wa1Timing = index-wa1Timer;
					wa1TimerList.add(wa1Timing);
					incorrectWa1=false;
				}
			}
			else if (trueAvl>=0.5 && wa1<0.5 || trueAvl<0.5 && wa1 >= 0.5){ //incorrect



				if(incorrectWa1!=true){
					wa1Timer = index;
				}
				incorrectWa1 = true;
			}
			//-----------------------------------------

			if(trueAvl>=0.5 && wa2>=0.5 || trueAvl<0.5 && wa2<0.5){
				wa2AvlCount++;
				if(incorrectWa2==true){
					wa2Timing = index-wa2Timer;
					wa2TimerList.add(wa2Timing);
					incorrectWa2=false;
				}
			}
			else if (trueAvl>=0.5 && wa2<0.5 || trueAvl<0.5 && wa2 >= 0.5){ //incorrect

				if(incorrectWa2!=true){
					wa2Timer = index;
				}
				incorrectWa2 = true;
			}

			//-----------------------------------------------
			if(trueAvl>=0.5 && wa3>=0.5 || trueAvl<0.5 && wa3<0.5){
				wa3AvlCount++;
				if(incorrectWa3==true){
					wa3Timing = index-wa3Timer;
					wa3TimerList.add(wa3Timing);
					incorrectWa3=false;
				}
			}
			else if (trueAvl>=0.5 && wa3<0.5 || trueAvl<0.5 && wa3 >= 0.5){ //incorrect

				if(incorrectWa3!=true){
					wa3Timer = index;
				}
				incorrectWa3 = true;
			}
			//-----------------------------------------------

			if(trueAvl>=0.5 && wa4>=0.5 || trueAvl<0.5 && wa4<0.5){
				wa4AvlCount++;
				if(incorrectWa4==true){
					wa4Timing = index-wa4Timer;
					wa4TimerList.add(wa4Timing);
					incorrectWa4=false;
				}
			}
			else if (trueAvl>=0.5 && wa4<0.5 || trueAvl<0.5 && wa4 >= 0.5){ //incorrect

				if(incorrectWa4!=true){
					wa4Timer = index;
				}
				incorrectWa4 = true;
			}

			//-------------------------------------------
			if(trueAvl>=0.5 && wa5>=0.5 || trueAvl<0.5 && wa5<0.5){
				wa5AvlCount++;
				if(incorrectWa5==true){
					wa5Timing = index-wa5Timer;
					wa5TimerList.add(wa5Timing);
					incorrectWa5=false;
				}
			}
			else if (trueAvl>=0.5 && wa5<0.5 || trueAvl<0.5 && wa5 >= 0.5){ //incorrect

				if(incorrectWa5!=true){
					wa5Timer = index;
				}
				incorrectWa5 = true;
			}


			//----------------------------------------------
			if(trueAvl>=0.5 && wa6>=0.5 || trueAvl<=0.5 && wa6<=0.5){
				wa6AvlCount++;
				if(incorrectWa6==true){
					wa6Timing = index-wa6Timer;
					wa6TimerList.add(wa6Timing);
					incorrectWa6=false;
				}
			}
			else if (trueAvl>=0.5 && wa6<0.5 || trueAvl<0.5 && wa6 >= 0.5){ //incorrect

				if(incorrectWa6!=true){
					wa6Timer = index;
				}
				incorrectWa6 = true;
			}

			//-------------------------------------------
			if(trueAvl>=0.5 && wa7>=0.5 || trueAvl<0.5 && wa7<0.5){
				wa7AvlCount++;
				if(incorrectWa7==true){
					wa7Timing = index-wa7Timer;
					wa7TimerList.add(wa7Timing);
					incorrectWa7=false;
				}
			}
			else if (trueAvl>=0.5 && wa7<0.5 || trueAvl<0.5 && wa7 >= 0.5){ //incorrect

				if(incorrectWa7!=true){
					wa7Timer = index;
				}
				incorrectWa7 = true;
			}

			//--------------------------------------------

			if(trueAvl>=0.5 && wa8>=0.5 || trueAvl<=0.5 && wa8<=0.5){
				wa8AvlCount++;
				if(incorrectWa8==true){
					wa8Timing = index-wa8Timer;
					wa8TimerList.add(wa8Timing);
					incorrectWa8=false;
				}

			}
			else if (trueAvl>=0.5 && wa8<0.5 || trueAvl<0.5 && wa8 >= 0.5){ //incorrect
				if(incorrectWa8!=true){
					wa8Timer = index;
				}
				incorrectWa8 = true;
			}
			//-------------------------------------------

			if(trueAvl>=0.5 && wa9>=0.5 || trueAvl<0.5 && wa9<0.5){
				wa9AvlCount++;
				if(debug)
					System.out.println("wa9AvlCount "+wa9AvlCount);
				if(incorrectWa9==true){
					wa9Timing = index-wa9Timer;
					wa9TimerList.add(wa9Timing);
					incorrectWa9=false;
				}
			}
			else if (trueAvl>=0.5 && wa9<0.5 || trueAvl<0.5 && wa9 >= 0.5){ //incorrect
				if(incorrectWa9!=true){
					wa9Timer = index;
				}
				incorrectWa9 = true;
			}

			if(trueAvl>=0.5 && wa10>=0.5 || trueAvl<0.5 && wa10<0.5){
				wa10AvlCount++;
				if(debug)
					System.out.println("wa10AvlCount "+wa10AvlCount);
				if(incorrectWa10==true){
					wa10Timing = index-wa10Timer;
					wa10TimerList.add(wa10Timing);
					incorrectWa10=false;
				}
			}
			else if (trueAvl>=0.5 && wa10<0.5 || trueAvl<0.5 && wa10 >= 0.5){ //incorrect

				if(incorrectWa10!=true){
					wa10Timer = index;
				}
				incorrectWa10 = true;
			}
		}

		//compute the average auto-correctness times
		obj.setKalmanAutoCorrectness(this.avgFrList(kalmanTimerList));
		obj.setSppAutoCorrectness(this.avgFrList(sppTimerList));
		obj.setHistAutoCorrectness(this.avgFrList(histTimerList));
		obj.setHapAutoCorrectness(this.avgFrList(hapTimerList));
		obj.setWa0AutoCorrectness(this.avgFrList(wa0TimerList));
		obj.setWa1AutoCorrectness(this.avgFrList(wa1TimerList));
		obj.setWa2AutoCorrectness(this.avgFrList(wa2TimerList));
		obj.setWa3AutoCorrectness(this.avgFrList(wa3TimerList));
		obj.setWa4AutoCorrectness(this.avgFrList(wa4TimerList));
		obj.setWa5AutoCorrectness(this.avgFrList(wa5TimerList));
		obj.setWa6AutoCorrectness(this.avgFrList(wa6TimerList));
		obj.setWa7AutoCorrectness(this.avgFrList(wa7TimerList));
		obj.setWa8AutoCorrectness(this.avgFrList(wa8TimerList));
		obj.setWa9AutoCorrectness(this.avgFrList(wa9TimerList));
		obj.setWa10AutoCorrectness(this.avgFrList(wa10TimerList));

		//compute the percent correct Boolean classification
		if(this.utility.getKmf_list().size()>0){
			obj.setKalmanBoolClassification(kalmanAvlCount/this.utility.getKmf_list().size());
			obj.setSppBoolClassification(sppAvlCount/this.utility.getKmf_list().size());
			obj.setHistBoolClassification(histAvlCount/this.utility.getKmf_list().size());
			obj.setHapBoolClassification(hapAvlCount/this.utility.getKmf_list().size());
			obj.setWa0BoolClassification(wa0AvlCount/this.utility.getKmf_list().size());
			obj.setWa1BoolClassification(wa1AvlCount/this.utility.getKmf_list().size());
			obj.setWa2BoolClassification(wa2AvlCount/this.utility.getKmf_list().size());
			obj.setWa3BoolClassification(wa3AvlCount/this.utility.getKmf_list().size());
			obj.setWa4BoolClassification(wa4AvlCount/this.utility.getKmf_list().size());
			obj.setWa5BoolClassification(wa5AvlCount/this.utility.getKmf_list().size());
			obj.setWa6BoolClassification(wa6AvlCount/this.utility.getKmf_list().size());
			obj.setWa7BoolClassification(wa7AvlCount/this.utility.getKmf_list().size());
			obj.setWa8BoolClassification(wa8AvlCount/this.utility.getKmf_list().size());
			obj.setWa9BoolClassification(wa9AvlCount/this.utility.getKmf_list().size());
			obj.setWa10BoolClassification(wa10AvlCount/this.utility.getKmf_list().size());

		}
	//System.err.println("size "+this.utility.getKmf_list().size());
		//System.err.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\n"+obj.toString());
		
		return obj;
	}




	public double avgFrList(ArrayList <Integer> list){
		double avg=0.0;
		double sum = 0.0;
		for(int index=0; index<list.size();index++){
			sum = sum+list.get(index);

		}

		if(list.size()!=0) {
			return (double)(sum/list.size());
		}
		else{
			return 0;
		}
	}

	ArrayList <Integer> equalTimePoints(ArrayList<Double> list, double val){
		ArrayList <Integer> recs = new ArrayList <Integer>();

		for(int index=0;index<list.size();index++){
			if(list.get(index)==val){

				recs.add(index);

			}
		}
		return recs;
	}


	@SuppressWarnings("deprecation")
	public PAEResultsObject runSimulationPerSecond() throws Exception{ 
		PrintWriter fout = new PrintWriter(new FileWriter("PAEOURISTUDY.txt",true),true);
		double final_rmse = 0.0,final_rmse_spp = 0.0,final_rmse_wa0 = 0.0,final_rmse_wa1 = 0.0,final_rmse_wa2 = 0.0,final_rmse_wa3 = 0.0,final_rmse_wa4 = 0.0,final_rmse_wa5 = 0.0,final_rmse_wa6 = 0.0,final_rmse_wa7 = 0.0,final_rmse_wa8 = 0.0,final_rmse_wa9 = 0.0,final_rmse_wa10 = 0.0,final_rmse_kmf = 0.0,final_rmse_qt = 0.0;
		int total_time_instance=0;
		double sum_ai = 0.0, sum_xi = 0.0, sum_qi = 0.0, sum_Qi = 0.0, sum_spp=0.0,sum_wa0=0.0,sum_wa1=0.0,sum_wa2=0.0,sum_wa3=0.0,sum_wa4=0.0,sum_wa5=0.0,sum_wa6=0.0,sum_wa7=0.0,sum_wa8=0.0,sum_wa9=0.0,sum_wa10=0.0,sum_kmf=0.0;
		double rmse=0.0,rmse_spp=0.0,rmse_wa0=0.0,rmse_wa1=0.0,rmse_wa2=0.0,rmse_wa3=0.0,rmse_wa4=0.0,rmse_wa5=0.0,rmse_wa6=0.0,rmse_wa7=0.0,rmse_wa8=0.0,rmse_wa9=0.0,rmse_wa10=0.0,rmse_kmf=0.0, rmse_qt=0.0;
		String result = "";

		Time start_of_permitted_period = new Time(14, 15, 0); // start of
		Time end_of_permitted_period = new Time(13, 15, 0); // end of permitted

		Calendar calendar = Calendar.getInstance();

		calendar.setTime(start_of_permitted_period);

		while (!calendar.getTime().toString()
				.contains(end_of_permitted_period.toString())) { // permitted
			//Iterator itr = permitted_index_list.iterator();
			String calendar_to_string = new Date(calendar.getTimeInMillis()).getHours()+":"+new Date(calendar.getTimeInMillis()).getMinutes();
			ArrayList <Integer> locations = this.equalTimePoints(this.utility.getTime_map_as_doubles(), this.utility.convertTimeStringToDouble(calendar_to_string) );// permitted_index_list.get(permitted_period), permitted_index_list.get(permitted_period+1));

			global_map_index = 0;
			if(locations!=null){
				for(int location:locations){
					if( location<this.utility.getHAP_list().size()){
						sum_ai = sum_ai + this.utility.getHAP_list().get(location);
						sum_xi = sum_xi
								+ this.utility.getTrue_avl_list().get(location);
						sum_qi = sum_qi
								+ this.utility.getHistorical_mean_list().get(location);
						//System.out.println("pre qi "+this.utility.getHistorical_mean_list().get(location));
						sum_Qi = sum_Qi
								+ this.utility.getHistorical_variance_list().get(
										location);
						sum_spp=sum_spp+ this.utility.getSpp_list().get(
								location);


						//System.out.println("pre spp "+this.utility.getSpp_list().get(
						//	location));
						sum_wa0=sum_wa0+ this.utility.getWa0_list().get(
								location);

						sum_wa1=sum_wa1+ this.utility.getWa1_list().get(
								location);
						sum_wa2=sum_wa2+ this.utility.getWa2_list().get(
								location);
						sum_wa3=sum_wa3+ this.utility.getWa3_list().get(
								location);
						sum_wa4=sum_wa4+ this.utility.getWa4_list().get(
								location);
						//System.out.println("pre wa4 "+this.utility.getWa4_list().get(
						//	location));

						sum_wa5=sum_wa5+ this.utility.getWa5_list().get(
								location);
						sum_wa6=sum_wa6+ this.utility.getWa6_list().get(
								location);
						sum_wa7=sum_wa7+ this.utility.getWa7_list().get(
								location);
						sum_wa8=sum_wa8+ this.utility.getWa8_list().get(
								location);
						sum_wa9=sum_wa9+ this.utility.getWa9_list().get(
								location);
						sum_wa10=sum_wa10+ this.utility.getWa10_list().get(
								location);


						sum_kmf=sum_kmf+this.utility.getKmf_list().get(
								location);


						//----------------------------------

						global_map_index++;
					}
				}
			}



			double mean_xi = sum_xi / permitted_index_list.size(); //true
			double mean_ai = sum_ai / permitted_index_list.size(); //HAP
			double mean_qi = sum_qi/permitted_index_list.size(); //historical mean
			double mean_spp = sum_spp / permitted_index_list.size();//scaled phonepark


			double mean_wa0 = sum_wa0 / permitted_index_list.size(); //weighted average
			double mean_wa1 = sum_wa1 / permitted_index_list.size(); //weighted average
			double mean_wa2 = sum_wa2 / permitted_index_list.size(); //weighted average
			double mean_wa3 = sum_wa3 / permitted_index_list.size(); //weighted average
			double mean_wa4 = sum_wa4 / permitted_index_list.size(); //weighted average

			double mean_wa5 = sum_wa5 / permitted_index_list.size(); //weighted average
			double mean_wa6 = sum_wa6 / permitted_index_list.size(); //weighted average
			double mean_wa7 = sum_wa7 / permitted_index_list.size(); //weighted average
			double mean_wa8 = sum_wa8 / permitted_index_list.size(); //weighted average
			double mean_wa9 = sum_wa9 / permitted_index_list.size(); //weighted average
			double mean_wa10 = sum_wa10 / permitted_index_list.size(); //weighted average
			double mean_kmf = sum_kmf / permitted_index_list.size(); //kalman filter

			/*
			System.out.println("mean_xi "+mean_xi );
			System.out.print(", mean_qi "+mean_qi );
			System.out.print(", mean_spp  "+mean_spp );
			System.out.print(", mean_wa0 "+mean_wa0);
			System.out.print(", mean_wa4 "+mean_wa4);
			System.out.print(", mean_wa5 "+mean_wa5);
			System.out.print(", mean_wa10 "+mean_wa10);*/

			fout.println("mean_xi "+mean_xi );
			fout.print(", mean_qi "+mean_qi );
			fout.print(", mean_spp  "+mean_spp );
			fout.print(", mean_wa0 "+mean_wa0);
			fout.print(", mean_wa4 "+mean_wa4);
			fout.print(", mean_wa5 "+mean_wa5);
			fout.print(", mean_wa10 "+mean_wa10);

			rmse = rmse + Math.pow((mean_xi-mean_ai),2); //HAP
			rmse_spp = rmse_spp + Math.pow((mean_xi-mean_spp),2);




			rmse_wa0 = rmse_wa0 + Math.pow((mean_xi-mean_wa0),2);
			rmse_wa1 = rmse_wa1 + Math.pow((mean_xi-mean_wa1),2);
			rmse_wa2 = rmse_wa2 + Math.pow((mean_xi-mean_wa2),2);
			rmse_wa3 = rmse_wa3 + Math.pow((mean_xi-mean_wa3),2);
			rmse_wa4 = rmse_wa4 + Math.pow((mean_xi-mean_wa4),2);



			rmse_wa5 = rmse_wa5 + Math.pow((mean_xi-mean_wa5),2);
			rmse_wa6 = rmse_wa6 + Math.pow((mean_xi-mean_wa6),2);
			rmse_wa7 = rmse_wa7 + Math.pow((mean_xi-mean_wa7),2);
			rmse_wa8 = rmse_wa8 + Math.pow((mean_xi-mean_wa8),2);
			rmse_wa9 = rmse_wa9 + Math.pow((mean_xi-mean_wa9),2);
			rmse_wa10 = rmse_wa10 + Math.pow((mean_xi-mean_wa10),2);

			rmse_qt = rmse_qt + Math.pow((mean_xi-mean_qi),2); //the real HAP



			rmse_kmf = rmse_kmf + Math.pow((mean_xi-mean_kmf),2);
			//System.out.println("---------------------------------");
			/*System.out.println("rmse "+rmse);
			System.out.print(", rmse_spp "+rmse_spp);
			System.out.print(", rmse_wa0 "+rmse_wa0);
			System.out.print(", rmse_wa4 "+rmse_wa4);
			System.out.print(", rmse_wa5 "+rmse_wa5);
			System.out.print(", rmse_wa10 "+rmse_wa10);
			System.out.print(", rmse_qt "+rmse_qt);*/

			fout.println("rmse "+rmse);
			fout.print(", rmse_spp "+rmse_spp);
			fout.print(", rmse_wa0 "+rmse_wa0);
			fout.print(", rmse_wa4 "+rmse_wa4);
			fout.print(", rmse_wa5 "+rmse_wa5);
			fout.print(", rmse_wa10 "+rmse_wa10);
			fout.print(", rmse_qt "+rmse_qt);

			total_time_instance++;

			sum_ai = 0.0;
			sum_xi = 0.0;
			sum_qi = 0.0;
			sum_Qi = 0.0;
			sum_spp=0.0;
			sum_wa0=0.0;sum_wa1=0.0;sum_wa2=0.0;sum_wa3=0.0;sum_wa4=0.0;sum_wa5=0.0;sum_wa6=0.0;sum_wa7=0.0;sum_wa8=0.0;sum_wa9=0.0;sum_wa10=0.0;
			sum_kmf=0.0;

			calendar.add(Calendar.MINUTE, 1);
		}

		rmse = rmse/total_time_instance;
		final_rmse = Math.sqrt(rmse);

		rmse_spp = rmse_spp/total_time_instance;
		final_rmse_spp = Math.sqrt(rmse_spp);

		rmse_wa0 = rmse_wa0/total_time_instance;
		final_rmse_wa0 = Math.sqrt(rmse_wa0);

		rmse_wa1 = rmse_wa1/total_time_instance;
		final_rmse_wa1 = Math.sqrt(rmse_wa1);

		rmse_wa2 = rmse_wa2/total_time_instance;
		final_rmse_wa2 = Math.sqrt(rmse_wa2);

		rmse_wa3 = rmse_wa3/total_time_instance;
		final_rmse_wa3 = Math.sqrt(rmse_wa3);

		rmse_wa4 = rmse_wa4/total_time_instance;
		final_rmse_wa4 = Math.sqrt(rmse_wa4);

		rmse_wa5 = rmse_wa5/total_time_instance;
		final_rmse_wa5 = Math.sqrt(rmse_wa5);

		rmse_wa6 = rmse_wa6/total_time_instance;
		final_rmse_wa6 = Math.sqrt(rmse_wa6);

		rmse_wa7 = rmse_wa7/total_time_instance;
		final_rmse_wa7 = Math.sqrt(rmse_wa7);

		rmse_wa8 = rmse_wa8/total_time_instance;
		final_rmse_wa8 = Math.sqrt(rmse_wa8);

		rmse_wa9 = rmse_wa9/total_time_instance;
		final_rmse_wa9 = Math.sqrt(rmse_wa9);

		rmse_wa10 = rmse_wa10/total_time_instance;
		final_rmse_wa10 = Math.sqrt(rmse_wa10);

		rmse_kmf = rmse_kmf/total_time_instance;
		final_rmse_kmf = Math.sqrt(rmse_kmf);

		rmse_qt = rmse_qt/total_time_instance;
		final_rmse_qt = Math.sqrt(rmse_qt);

		/*System.out.println("\n\ntotal time instance "+total_time_instance);
		//System.out.println("RMSE HA= "+final_rmse);

		System.out.println("RMSE HAP= "+final_rmse);
		System.out.println("RMSE KMF= "+final_rmse_kmf);
		System.out.println("RMSE WA0= "+final_rmse_wa0);
		System.out.println("RMSE WA1= "+final_rmse_wa1);
		System.out.println("RMSE WA2= "+final_rmse_wa2);
		System.out.println("RMSE WA3= "+final_rmse_wa3);
		System.out.println("RMSE WA4= "+final_rmse_wa4);
		System.out.println("RMSE WA5= "+final_rmse_wa5);
		System.out.println("RMSE WA6= "+final_rmse_wa6);
		System.out.println("RMSE WA7= "+final_rmse_wa7);
		System.out.println("RMSE WA8= "+final_rmse_wa8);
		System.out.println("RMSE WA9= "+final_rmse_wa9);
		System.out.println("RMSE WA10= "+final_rmse_wa10);
		System.out.println("RMSE SPP= "+final_rmse_spp);
		System.out.println("RMSE HAP qt= "+final_rmse_qt);*/


		/*this.out.println("RMSE HAP= "+final_rmse);
		this.out.println("RMSE KMF= "+final_rmse_kmf);
		this.out.println("RMSE WA0= "+final_rmse_wa0);
		this.out.println("RMSE WA1= "+final_rmse_wa1);
		this.out.println("RMSE WA2= "+final_rmse_wa2);
		this.out.println("RMSE WA3= "+final_rmse_wa3);
		this.out.println("RMSE WA4= "+final_rmse_wa4);
		this.out.println("RMSE WA5= "+final_rmse_wa5);
		this.out.println("RMSE WA6= "+final_rmse_wa6);
		this.out.println("RMSE WA7= "+final_rmse_wa7);
		this.out.println("RMSE WA8= "+final_rmse_wa8);
		this.out.println("RMSE WA9= "+final_rmse_wa9);
		this.out.println("RMSE WA10= "+final_rmse_wa10);
		this.out.println("RMSE SPP= "+final_rmse_spp);
		this.out.println("RMSE qt= "+final_rmse_qt);*/

		PAEResultsObject pae_result = new PAEResultsObject(final_rmse_kmf, final_rmse_qt, final_rmse_spp,
				final_rmse_wa0,  final_rmse_wa1,  final_rmse_wa2,  final_rmse_wa3,
				final_rmse_wa4, final_rmse_wa5, final_rmse_wa6,  final_rmse_wa7,
				final_rmse_wa8,  final_rmse_wa9,  final_rmse_wa10,final_rmse);

		return pae_result;
	}

	@SuppressWarnings("deprecation")
	public PAEResultsObject runSimulation() throws Exception{
		PrintWriter fout = new PrintWriter(new FileWriter("PAEOURISTUDY.txt",true),true);
		double final_rmse = 0.0,final_rmse_spp = 0.0,final_rmse_wa0 = 0.0,final_rmse_wa1 = 0.0,final_rmse_wa2 = 0.0,final_rmse_wa3 = 0.0,final_rmse_wa4 = 0.0,final_rmse_wa5 = 0.0,final_rmse_wa6 = 0.0,final_rmse_wa7 = 0.0,final_rmse_wa8 = 0.0,final_rmse_wa9 = 0.0,final_rmse_wa10 = 0.0,final_rmse_kmf = 0.0,final_rmse_qt = 0.0;
		int total_time_instance=0;
		double sum_ai = 0.0, sum_xi = 0.0, sum_qi = 0.0, sum_Qi = 0.0, sum_spp=0.0,sum_wa0=0.0,sum_wa1=0.0,sum_wa2=0.0,sum_wa3=0.0,sum_wa4=0.0,sum_wa5=0.0,sum_wa6=0.0,sum_wa7=0.0,sum_wa8=0.0,sum_wa9=0.0,sum_wa10=0.0,sum_kmf=0.0;
		double rmse=0.0,rmse_spp=0.0,rmse_wa0=0.0,rmse_wa1=0.0,rmse_wa2=0.0,rmse_wa3=0.0,rmse_wa4=0.0,rmse_wa5=0.0,rmse_wa6=0.0,rmse_wa7=0.0,rmse_wa8=0.0,rmse_wa9=0.0,rmse_wa10=0.0,rmse_kmf=0.0, rmse_qt=0.0;
		String result = "";
		Time start_of_permitted_period = new Time(14, 15, 0); // start of
		Time end_of_permitted_period = new Time(13, 40, 0); // end of permitted

		Calendar calendar = Calendar.getInstance();

		calendar.setTime(start_of_permitted_period);

		while (!calendar.getTime().toString()
				.contains(end_of_permitted_period.toString())) { // permitted
			//Iterator itr = permitted_index_list.iterator();
			global_map_index = 0;
			for(int permitted_period=0;permitted_period<permitted_index_list.size();permitted_period++){
				if((permitted_period+1)<permitted_index_list.size()){
					String calendar_to_string = new Date(calendar.getTimeInMillis()).getHours()+":"+new Date(calendar.getTimeInMillis()).getMinutes();
					int location = this.closestTimePoint(this.utility.getTime_map_as_doubles(), this.utility.convertTimeStringToDouble(calendar_to_string), permitted_index_list.get(permitted_period), permitted_index_list.get(permitted_period+1));
					//if (location>= permitted_index_list.get(permitted_period)&&location<=permitted_index_list.get(permitted_period+1)){
					sum_ai = sum_ai + this.utility.getHAP_list().get(location);
					sum_xi = sum_xi
							+ this.utility.getTrue_avl_list().get(location);
					sum_qi = sum_qi
							+ this.utility.getHistorical_mean_list().get(location);
					//System.out.println("pre qi "+this.utility.getHistorical_mean_list().get(location));
					sum_Qi = sum_Qi
							+ this.utility.getHistorical_variance_list().get(
									location);
					sum_spp=sum_spp+ this.utility.getSpp_list().get(
							location);


					//System.out.println("pre spp "+this.utility.getSpp_list().get(
					//	location));
					sum_wa0=sum_wa0+ this.utility.getWa0_list().get(
							location);

					sum_wa1=sum_wa1+ this.utility.getWa1_list().get(
							location);
					sum_wa2=sum_wa2+ this.utility.getWa2_list().get(
							location);
					sum_wa3=sum_wa3+ this.utility.getWa3_list().get(
							location);
					sum_wa4=sum_wa4+ this.utility.getWa4_list().get(
							location);
					//System.out.println("pre wa4 "+this.utility.getWa4_list().get(
					//	location));

					sum_wa5=sum_wa5+ this.utility.getWa5_list().get(
							location);
					sum_wa6=sum_wa6+ this.utility.getWa6_list().get(
							location);
					sum_wa7=sum_wa7+ this.utility.getWa7_list().get(
							location);
					sum_wa8=sum_wa8+ this.utility.getWa8_list().get(
							location);
					sum_wa9=sum_wa9+ this.utility.getWa9_list().get(
							location);
					sum_wa10=sum_wa10+ this.utility.getWa10_list().get(
							location);


					sum_kmf=sum_kmf+this.utility.getKmf_list().get(
							location);


					//----------------------------------















					global_map_index++;
					//}
				}
			}



			double mean_xi = sum_xi / permitted_index_list.size(); //true
			double mean_ai = sum_ai / permitted_index_list.size(); //HAP
			double mean_qi = sum_qi/permitted_index_list.size(); //historical mean
			double mean_spp = sum_spp / permitted_index_list.size();//scaled phonepark


			double mean_wa0 = sum_wa0 / permitted_index_list.size(); //weighted average
			double mean_wa1 = sum_wa1 / permitted_index_list.size(); //weighted average
			double mean_wa2 = sum_wa2 / permitted_index_list.size(); //weighted average
			double mean_wa3 = sum_wa3 / permitted_index_list.size(); //weighted average
			double mean_wa4 = sum_wa4 / permitted_index_list.size(); //weighted average

			double mean_wa5 = sum_wa5 / permitted_index_list.size(); //weighted average
			double mean_wa6 = sum_wa6 / permitted_index_list.size(); //weighted average
			double mean_wa7 = sum_wa7 / permitted_index_list.size(); //weighted average
			double mean_wa8 = sum_wa8 / permitted_index_list.size(); //weighted average
			double mean_wa9 = sum_wa9 / permitted_index_list.size(); //weighted average
			double mean_wa10 = sum_wa10 / permitted_index_list.size(); //weighted average
			double mean_kmf = sum_kmf / permitted_index_list.size(); //kalman filter

			/*
			System.out.println("mean_xi "+mean_xi );
			System.out.print(", mean_qi "+mean_qi );
			System.out.print(", mean_spp  "+mean_spp );
			System.out.print(", mean_wa0 "+mean_wa0);
			System.out.print(", mean_wa4 "+mean_wa4);
			System.out.print(", mean_wa5 "+mean_wa5);
			System.out.print(", mean_wa10 "+mean_wa10);*/

			fout.println("mean_xi "+mean_xi );
			fout.print(", mean_qi "+mean_qi );
			fout.print(", mean_spp  "+mean_spp );
			fout.print(", mean_wa0 "+mean_wa0);
			fout.print(", mean_wa4 "+mean_wa4);
			fout.print(", mean_wa5 "+mean_wa5);
			fout.print(", mean_wa10 "+mean_wa10);

			rmse = rmse + Math.pow((mean_xi-mean_ai),2); //HAP
			rmse_spp = rmse_spp + Math.pow((mean_xi-mean_spp),2);




			rmse_wa0 = rmse_wa0 + Math.pow((mean_xi-mean_wa0),2);
			rmse_wa1 = rmse_wa1 + Math.pow((mean_xi-mean_wa1),2);
			rmse_wa2 = rmse_wa2 + Math.pow((mean_xi-mean_wa2),2);
			rmse_wa3 = rmse_wa3 + Math.pow((mean_xi-mean_wa3),2);
			rmse_wa4 = rmse_wa4 + Math.pow((mean_xi-mean_wa4),2);



			rmse_wa5 = rmse_wa5 + Math.pow((mean_xi-mean_wa5),2);
			rmse_wa6 = rmse_wa6 + Math.pow((mean_xi-mean_wa6),2);
			rmse_wa7 = rmse_wa7 + Math.pow((mean_xi-mean_wa7),2);
			rmse_wa8 = rmse_wa8 + Math.pow((mean_xi-mean_wa8),2);
			rmse_wa9 = rmse_wa9 + Math.pow((mean_xi-mean_wa9),2);
			rmse_wa10 = rmse_wa10 + Math.pow((mean_xi-mean_wa10),2);

			rmse_qt = rmse_qt + Math.pow((mean_xi-mean_qi),2); //the real HAP



			rmse_kmf = rmse_kmf + Math.pow((mean_xi-mean_kmf),2);
			//	System.out.println("---------------------------------");
			/*System.out.println("rmse "+rmse);
			System.out.print(", rmse_spp "+rmse_spp);
			System.out.print(", rmse_wa0 "+rmse_wa0);
			System.out.print(", rmse_wa4 "+rmse_wa4);
			System.out.print(", rmse_wa5 "+rmse_wa5);
			System.out.print(", rmse_wa10 "+rmse_wa10);
			System.out.print(", rmse_qt "+rmse_qt);*/

			fout.println("rmse "+rmse);
			fout.print(", rmse_spp "+rmse_spp);
			fout.print(", rmse_wa0 "+rmse_wa0);
			fout.print(", rmse_wa4 "+rmse_wa4);
			fout.print(", rmse_wa5 "+rmse_wa5);
			fout.print(", rmse_wa10 "+rmse_wa10);
			fout.print(", rmse_qt "+rmse_qt);

			total_time_instance++;

			sum_ai = 0.0;
			sum_xi = 0.0;
			sum_qi = 0.0;
			sum_Qi = 0.0;
			sum_spp=0.0;
			sum_wa0=0.0;sum_wa1=0.0;sum_wa2=0.0;sum_wa3=0.0;sum_wa4=0.0;sum_wa5=0.0;sum_wa6=0.0;sum_wa7=0.0;sum_wa8=0.0;sum_wa9=0.0;sum_wa10=0.0;
			sum_kmf=0.0;

			calendar.add(Calendar.MINUTE, 1);
		}

		rmse = rmse/total_time_instance;
		final_rmse = Math.sqrt(rmse);

		rmse_spp = rmse_spp/total_time_instance;
		final_rmse_spp = Math.sqrt(rmse_spp);

		rmse_wa0 = rmse_wa0/total_time_instance;
		final_rmse_wa0 = Math.sqrt(rmse_wa0);

		rmse_wa1 = rmse_wa1/total_time_instance;
		final_rmse_wa1 = Math.sqrt(rmse_wa1);

		rmse_wa2 = rmse_wa2/total_time_instance;
		final_rmse_wa2 = Math.sqrt(rmse_wa2);

		rmse_wa3 = rmse_wa3/total_time_instance;
		final_rmse_wa3 = Math.sqrt(rmse_wa3);

		rmse_wa4 = rmse_wa4/total_time_instance;
		final_rmse_wa4 = Math.sqrt(rmse_wa4);

		rmse_wa5 = rmse_wa5/total_time_instance;
		final_rmse_wa5 = Math.sqrt(rmse_wa5);

		rmse_wa6 = rmse_wa6/total_time_instance;
		final_rmse_wa6 = Math.sqrt(rmse_wa6);

		rmse_wa7 = rmse_wa7/total_time_instance;
		final_rmse_wa7 = Math.sqrt(rmse_wa7);

		rmse_wa8 = rmse_wa8/total_time_instance;
		final_rmse_wa8 = Math.sqrt(rmse_wa8);

		rmse_wa9 = rmse_wa9/total_time_instance;
		final_rmse_wa9 = Math.sqrt(rmse_wa9);

		rmse_wa10 = rmse_wa10/total_time_instance;
		final_rmse_wa10 = Math.sqrt(rmse_wa10);

		rmse_kmf = rmse_kmf/total_time_instance;
		final_rmse_kmf = Math.sqrt(rmse_kmf);

		rmse_qt = rmse_qt/total_time_instance;
		final_rmse_qt = Math.sqrt(rmse_qt);

		System.out.println("\n\ntotal time instance "+total_time_instance);
		//System.out.println("RMSE HA= "+final_rmse);

		System.out.println("RMSE HAP= "+final_rmse);
		System.out.println("RMSE KMF= "+final_rmse_kmf);
		System.out.println("RMSE WA0= "+final_rmse_wa0);
		System.out.println("RMSE WA1= "+final_rmse_wa1);
		System.out.println("RMSE WA2= "+final_rmse_wa2);
		System.out.println("RMSE WA3= "+final_rmse_wa3);
		System.out.println("RMSE WA4= "+final_rmse_wa4);
		System.out.println("RMSE WA5= "+final_rmse_wa5);
		System.out.println("RMSE WA6= "+final_rmse_wa6);
		System.out.println("RMSE WA7= "+final_rmse_wa7);
		System.out.println("RMSE WA8= "+final_rmse_wa8);
		System.out.println("RMSE WA9= "+final_rmse_wa9);
		System.out.println("RMSE WA10= "+final_rmse_wa10);
		System.out.println("RMSE SPP= "+final_rmse_spp);
		System.out.println("RMSE HAP qt= "+final_rmse_qt);


		/*this.out.println("RMSE HAP= "+final_rmse);
		this.out.println("RMSE KMF= "+final_rmse_kmf);
		this.out.println("RMSE WA0= "+final_rmse_wa0);
		this.out.println("RMSE WA1= "+final_rmse_wa1);
		this.out.println("RMSE WA2= "+final_rmse_wa2);
		this.out.println("RMSE WA3= "+final_rmse_wa3);
		this.out.println("RMSE WA4= "+final_rmse_wa4);
		this.out.println("RMSE WA5= "+final_rmse_wa5);
		this.out.println("RMSE WA6= "+final_rmse_wa6);
		this.out.println("RMSE WA7= "+final_rmse_wa7);
		this.out.println("RMSE WA8= "+final_rmse_wa8);
		this.out.println("RMSE WA9= "+final_rmse_wa9);
		this.out.println("RMSE WA10= "+final_rmse_wa10);
		this.out.println("RMSE SPP= "+final_rmse_spp);
		this.out.println("RMSE qt= "+final_rmse_qt);*/

		PAEResultsObject pae_result = new PAEResultsObject(final_rmse_kmf, final_rmse_qt, final_rmse_spp,
				final_rmse_wa0,  final_rmse_wa1,  final_rmse_wa2,  final_rmse_wa3,
				final_rmse_wa4, final_rmse_wa5, final_rmse_wa6,  final_rmse_wa7,
				final_rmse_wa8,  final_rmse_wa9,  final_rmse_wa10,final_rmse);

		return pae_result;
	}

	int closestTimePoint(ArrayList <Double> times, double time, int low, int high){
		int found_index=0;
		double closest = 1000.00;
		for (int index=low;index<high;index++){
			if(index<times.size()){
				if(time-times.get(index)>0 && (time-times.get(index))<closest){
					closest = (time-times.get(index));
					found_index = index;
				}
			}
		}

		return found_index;

	}


	public void generateFalsePositive(String instruction){
		double prob = randomizer.nextDouble();
		if (prob<=this.haptest.getHap().getFp()) {
			if (instruction.equals("increase")) {
				this.haptest.increaseParkingAvailability();
				System.err.println("i-type false positive report observed");
			}
			else if (instruction.equals("decrease")) {
				this.haptest.decreaseParkingAvailability();
				System.err.println("d- type false positive report observed");
			}
		}
	}

}
