package com.parking.sourcing;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * @author leon stenneth, lstennethATgmail.com
 *
 */

//this class collects the sf park data from the api to validate the HAP and the PAE
public class SFPark {
	private Connection db,db2;
	private Statement stmt,stmt2;
	private  ResultSet rs;
	int rs2 ; 


	int time_interval = 1;


	public static void main(String args []){
		while (true){
			SFPark sfpark = new SFPark ();
			sfpark.readFromSFParkURL();
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	public String readFromSFParkURL (){
		String SFParkData = null;
		String url = "http://api.sfpark.org/sfpark/rest/availabilityservice?lat=37.792275&long=-122.397089&radius=10000&uom=mile&response=xml";

		try {
			//File file = new File("c:\\MyXMLFile.xml");
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			Document doc = db.parse(url);
			doc.getDocumentElement().normalize();
			System.out.println("Root element " + doc.getDocumentElement().getNodeName());
			NodeList nodeLst = doc.getElementsByTagName("AVL");
			System.out.println("Information of all AVL");
			String type, bfid,name=null, loc = null;
			int oper, occ, avl; 
			double start_lat, start_lon, end_lat, end_lon;
			for (int s = 0; s < nodeLst.getLength(); s++) {

				Node fstNode = nodeLst.item(s);

				if (fstNode.getNodeType() == Node.ELEMENT_NODE) {

					Element fstElmnt = (Element) fstNode;
					NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("TYPE");
					Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
					NodeList fstNm = fstNmElmnt.getChildNodes();
					type = ((Node) fstNm.item(0)).getNodeValue();
					if (type.equals("ON")){

						NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("OPER");
						Element  lstNmElmnt = (Element) lstNmElmntLst.item(0);
						if(lstNmElmnt!=null){
							NodeList  lstNm = lstNmElmnt.getChildNodes();
							oper = Integer.parseInt(((Node) lstNm.item(0)).getNodeValue());

							if (oper >=0) {
								System.out.println("-----------------------------------\nOPER : " +  oper); 
								lstNmElmntLst = fstElmnt.getElementsByTagName("BFID");
								lstNmElmnt = (Element) lstNmElmntLst.item(0);
								lstNm = lstNmElmnt.getChildNodes();
								bfid = ((Node) lstNm.item(0)).getNodeValue();
								System.out.println("BFID : " +  bfid); 

								lstNmElmntLst = fstElmnt.getElementsByTagName("OCC");
								lstNmElmnt = (Element) lstNmElmntLst.item(0);
								lstNm = lstNmElmnt.getChildNodes();
								occ = Integer.parseInt(((Node) lstNm.item(0)).getNodeValue());
								System.out.println("OCC : " +  occ);

								//lstNmElmntLst = fstElmnt.getElementsByTagName("OCC");
								//lstNmElmnt = (Element) lstNmElmntLst.item(0);
								//lstNm = lstNmElmnt.getChildNodes();
								avl = oper - occ;
								System.out.println("AVL : " +  avl);

								lstNmElmntLst = fstElmnt.getElementsByTagName("NAME");
								lstNmElmnt = (Element) lstNmElmntLst.item(0);
								lstNm = lstNmElmnt.getChildNodes();
								name = ((Node) lstNm.item(0)).getNodeValue();//.replace("(", "").replace(")", "").replace("St", "street");
								System.out.println("NAME : " +  name);


								lstNmElmntLst = fstElmnt.getElementsByTagName("LOC");
								lstNmElmnt = (Element) lstNmElmntLst.item(0);
								lstNm = lstNmElmnt.getChildNodes();
								loc = ((Node) lstNm.item(0)).getNodeValue();//.replace("(", "").replace(")", "").replace("St", "street");
								System.out.println("LOC : " +  loc);
								start_lon = Double.parseDouble(loc.split(",") [0]); 
								start_lat = Double.parseDouble(loc.split(",") [1]);
								end_lon = Double.parseDouble(loc.split(",") [2]);
								end_lat = Double.parseDouble(loc.split(",") [3]);

								connectToDBandStore (bfid, name, oper, occ, avl,start_lat, start_lon, end_lat, end_lon);
								/*if(bfid.equals("328001")){
									FileWriter testFile = new FileWriter("");
									PrintWriter outToFile = new PrintWriter(testFile);
									outToFile.println();
									testFile.close();
									outToFile.close();
								}*/

							}
						}
					}

				}

			}
		} catch (Exception e) {
			e.printStackTrace();
		}



		return SFParkData;
	}
	public void connectToDBandStore (String bfid, String name, int oper, int occ, int avl, double start_lat, double start_lon,double end_lat,double end_lon){

		try {
			Class.forName("org.postgresql.Driver").newInstance();
			db=DriverManager.getConnection("jdbc:postgresql://localhost:5432/postgis","postgres","Yhcaapa3");	
			db2=DriverManager.getConnection("jdbc:postgresql://localhost:5432/postgis","postgres","Yhcaapa3");	

			stmt=db.createStatement();
			stmt2=db2.createStatement();
			String recent = "SELECT bfid, occupied,timestamp FROM sfpark where bfid='"+bfid+"' order by timestamp DESC limit 1";
			//String recent = "SELECT distinct bfid, occupied,timestamp FROM sfpark where timestamp >  now()-interval \'2 seconds\' ORDER BY timestamp";// >  now()-interval \'2 seconds\' AND occupied <> "+occ;

			rs = stmt.executeQuery(recent);
			if (rs.next()){
				//if (bfid.equals(rs.getString(1))){
				if(occ!=rs.getInt(2)){
					String query  = "INSERT INTO sfpark (bfid, name_address, operational, occupied, available,timestamp, lat_start, lon_start, lat_end, lon_end) VALUES ("+bfid+",'"+name+"',"+oper+","+occ+","+avl+", now(),"+start_lat+","+start_lon+","+end_lat+","+end_lon+")";// where "+bfid+" NOT IN (SELECT bfid, occ FROM sfpark where timestamp >  now()-interval \'1.5 seconds\' AND occupied <> "+occ;
					rs2 = stmt.executeUpdate(query);
					System.out.println(query +"\n Inserted........");
				}
				//}
			}


			else {

				String query  = "INSERT INTO sfpark (bfid, name_address, operational, occupied, available,timestamp, lat_start, lon_start, lat_end, lon_end) VALUES ("+bfid+",'"+name+"',"+oper+","+occ+","+avl+", now(),"+start_lat+","+start_lon+","+end_lat+","+end_lon+")";// where "+bfid+" NOT IN (SELECT bfid, occ FROM sfpark where timestamp >  now()-interval \'1.5 seconds\' AND occupied <> "+occ;
				rs2 = stmt.executeUpdate(query);
				System.out.println(query);

			}

			rs.close();
			stmt.close();
			stmt2.close();
			db.close();
			db2.close();
			//String SFParkData = readFromSFParkURL();
			//only those that are updated in the last 210 seconds..filtering...


		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

}
